// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/AdverseWeatherConditionAdhesionSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/adverse_weather_condition_adhesion_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x13, 0x75, 0x0e, 0xaa, 0x30, 0x09, 0x61, 0x6d,
      0x09, 0x6c, 0x12, 0xe1, 0x43, 0x6a, 0x48, 0xb3,
      0x91, 0xc0, 0x68, 0x4b, 0x15, 0xc2, 0xf0, 0x93,
      0xd6, 0x6d, 0x75, 0xdd, 0x9f, 0x7e, 0xd1, 0xd9,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/AdverseWeatherConditionAdhesionSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__TYPE_NAME, 69, 69},
      {etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the value of the sub cause code of the @ref CauseCode `adverseWeatherCondition-Adhesion`. \n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - 0 - `unavailable`     - in case information on the cause of the low road adhesion is unavailable,\n"
  "#  * - 1 - `heavyFrostOnRoad`- in case the low road adhesion is due to heavy frost on the road,\n"
  "#  * - 2 - `fuelOnRoad`      - in case the low road adhesion is due to fuel on the road,\n"
  "#  * - 3 - `mudOnRoad`       - in case the low road adhesion is due to mud on the road,\n"
  "#  * - 4 - `snowOnRoad`      - in case the low road adhesion is due to snow on the road,\n"
  "#  * - 5 - `iceOnRoad`       - in case the low road adhesion is due to ice on the road,\n"
  "#  * - 6 - `blackIceOnRoad`  - in case the low road adhesion is due to black ice on the road,\n"
  "#  * - 7 - `oilOnRoad`       - in case the low road adhesion is due to oil on the road,\n"
  "#  * - 8 - `looseChippings`  - in case the low road adhesion is due to loose gravel or stone fragments detached from a road surface or from a hazard,\n"
  "#  * - 9 - `instantBlackIce` - in case the low road adhesion is due to instant black ice on the road surface,\n"
  "#  * - 10 - `roadsSalted`    - when the low road adhesion is due to salted road,\n"
  "#  * - 11-255                - are reserved for future usage.\n"
  "#  *\n"
  "#  * @category: Traffic information\n"
  "#  * @revision: V1.3.1\n"
  "#  */\n"
  "# AdverseWeatherCondition-AdhesionSubCauseCode ::= INTEGER {\n"
  "#     unavailable      (0),\n"
  "#     heavyFrostOnRoad (1),\n"
  "#     fuelOnRoad       (2),\n"
  "#     mudOnRoad        (3),\n"
  "#     snowOnRoad       (4),\n"
  "#     iceOnRoad        (5),\n"
  "#     blackIceOnRoad   (6),\n"
  "#     oilOnRoad        (7),\n"
  "#     looseChippings   (8),\n"
  "#     instantBlackIce  (9),\n"
  "#     roadsSalted      (10)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 HEAVY_FROST_ON_ROAD = 1\n"
  "uint8 FUEL_ON_ROAD = 2\n"
  "uint8 MUD_ON_ROAD = 3\n"
  "uint8 SNOW_ON_ROAD = 4\n"
  "uint8 ICE_ON_ROAD = 5\n"
  "uint8 BLACK_ICE_ON_ROAD = 6\n"
  "uint8 OIL_ON_ROAD = 7\n"
  "uint8 LOOSE_CHIPPINGS = 8\n"
  "uint8 INSTANT_BLACK_ICE = 9\n"
  "uint8 ROADS_SALTED = 10\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__TYPE_NAME, 69, 69},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3949, 3949},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__AdverseWeatherConditionAdhesionSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
