// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/CartesianCoordinateSmall.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/cartesian_coordinate_small__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xd6, 0xaa, 0x86, 0x56, 0xee, 0xee, 0xec, 0x9a,
      0x1a, 0x5b, 0xda, 0xc7, 0xf0, 0x1e, 0x68, 0x53,
      0x5b, 0x99, 0xb6, 0xd1, 0x98, 0xf4, 0x37, 0x17,
      0x95, 0xe1, 0x7f, 0xc1, 0x0c, 0x60, 0x85, 0x1d,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/CartesianCoordinateSmall";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__TYPE_NAME, 50, 50},
      {etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DF represents the value of a cartesian coordinate with a range of -30,94 metres to +10,00 metres.\n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - `3094` if the longitudinal offset is out of range, i.e. less than or equal to -30,94 metres,\n"
  "#  * - `n` (`n > -3 094` and `n < 1 001`) if the longitudinal offset information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,\n"
  "#  * - `1001` if the longitudinal offset is out of range, i.e. greater than 10 metres.\n"
  "#  *\n"
  "#  * @unit 0,01 m\n"
  "#  * @category: Basic information\n"
  "#  * @revision: Created in V2.1.1\n"
  "# */\n"
  "# CartesianCoordinateSmall::= INTEGER {\n"
  "#     negativeOutOfRange (-3094),\n"
  "#     positiveOutOfRange (1001)\n"
  "# } (-3094..1001) \n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "int16 value\n"
  "int16 MIN = -3094\n"
  "int16 MAX = 1001\n"
  "int16 NEGATIVE_OUT_OF_RANGE = -3094\n"
  "int16 POSITIVE_OUT_OF_RANGE = 1001\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__TYPE_NAME, 50, 50},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2718, 2718},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__CartesianCoordinateSmall__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
