// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/CollisionRiskSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/collision_risk_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x38, 0x4a, 0x34, 0x0e, 0x1c, 0x66, 0x04, 0x68,
      0xdb, 0x72, 0x15, 0x7c, 0x6e, 0x73, 0x73, 0x38,
      0x08, 0x07, 0xd0, 0xa4, 0x7a, 0x5a, 0x44, 0x73,
      0xe9, 0x19, 0x0c, 0x59, 0x21, 0x90, 0x02, 0x46,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/CollisionRiskSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__TYPE_NAME, 51, 51},
      {etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the sub cause codes of the @ref CauseCode `collisionRisk`.\n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - 0 - `unavailable`                    - in case information on the type of collision risk is unavailable,\n"
  "#  * - 1 - `longitudinalCollisionRisk`      - in case the type of detected collision risk is longitudinal collision risk, \n"
  "#  *                                          e.g. forward collision or face to face collision,\n"
  "#  * - 2 - `crossingCollisionRisk`          - in case the type of detected collision risk is crossing collision risk,\n"
  "#  * - 3 - `lateralCollisionRisk`           - in case the type of detected collision risk is lateral collision risk,\n"
  "#  * - 4 - `vulnerableRoadUser`             - in case the type of detected collision risk involves vulnerable road users\n"
  "#  *                                          e.g. pedestrians or bicycles.\n"
  "#  * - 5 - `collisionRiskWithPedestrian`    - in case the type of detected collision risk involves at least one pedestrian, \n"
  "#  * - 6 - `collisionRiskWithCyclist`       - in case the type of detected collision risk involves at least one cyclist (and no pedestrians),\n"
  "#  * - 7 - `collisionRiskWithMotorVehicle`  - in case the type of detected collision risk involves at least one motor vehicle (and no pedestrians or cyclists),\n"
  "#  * - 8-255                                - are reserved for future usage.\n"
  "#  *\n"
  "#  * @category: Traffic information\n"
  "#  * @revision: V1.3.1, values 5-7 assigned in V2.2.1\n"
  "#  */\n"
  "# CollisionRiskSubCauseCode ::= INTEGER {\n"
  "#     unavailable                   (0), \n"
  "#     longitudinalCollisionRisk     (1), \n"
  "#     crossingCollisionRisk         (2), \n"
  "#     lateralCollisionRisk          (3), \n"
  "#     vulnerableRoadUser            (4),\n"
  "#     collisionRiskWithPedestrian   (5), \n"
  "#     collisionRiskWithCyclist      (6), \n"
  "#     collisionRiskWithMotorVehicle (7) \n"
  "# }(0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 LONGITUDINAL_COLLISION_RISK = 1\n"
  "uint8 CROSSING_COLLISION_RISK = 2\n"
  "uint8 LATERAL_COLLISION_RISK = 3\n"
  "uint8 VULNERABLE_ROAD_USER = 4\n"
  "uint8 COLLISION_RISK_WITH_PEDESTRIAN = 5\n"
  "uint8 COLLISION_RISK_WITH_CYCLIST = 6\n"
  "uint8 COLLISION_RISK_WITH_MOTOR_VEHICLE = 7\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__TYPE_NAME, 51, 51},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 4092, 4092},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__CollisionRiskSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
