// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/Direction.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/direction.h"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__DIRECTION__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__DIRECTION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'MIN'.
enum
{
  etsi_its_denm_ts_msgs__msg__Direction__MIN = 0
};

/// Constant 'MAX'.
enum
{
  etsi_its_denm_ts_msgs__msg__Direction__MAX = 3
};

/// Constant 'SAME_DIRECTION'.
enum
{
  etsi_its_denm_ts_msgs__msg__Direction__SAME_DIRECTION = 0
};

/// Constant 'OPPOSITE_DIRECTION'.
enum
{
  etsi_its_denm_ts_msgs__msg__Direction__OPPOSITE_DIRECTION = 1
};

/// Constant 'BOTH_DIRECTIONS'.
enum
{
  etsi_its_denm_ts_msgs__msg__Direction__BOTH_DIRECTIONS = 2
};

/// Constant 'UNAVAILABLE'.
enum
{
  etsi_its_denm_ts_msgs__msg__Direction__UNAVAILABLE = 3
};

/// Struct defined in msg/Direction in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__Direction
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates a direction with respect to a defined reference direction.
  ///  * Example: a reference direction may be implicitly defined by the definition of a geographical zone.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 - `sameDirection`     - to indicate the same direction as the reference direction,
  ///  * - 1 - `oppositeDirection` - to indicate opposite direction as the reference direction,
  ///  * - 2 - `bothDirections`    - to indicate both directions, i.e. the same and the opposite direction,
  ///  * - 3 - `unavailable`       - to indicate that the information is unavailable.
  ///  *
  ///  * @category: GeoReference information
  ///  * @revision: Created in V2.1.1
  ///  */
  /// Direction::= INTEGER{
  ///     sameDirection     (0),
  ///     oppositeDirection (1),
  ///     bothDirections    (2),
  ///     unavailable       (3)
  ///  } (0..3)
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_denm_ts_msgs__msg__Direction;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__Direction.
typedef struct etsi_its_denm_ts_msgs__msg__Direction__Sequence
{
  etsi_its_denm_ts_msgs__msg__Direction * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__Direction__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__DIRECTION__STRUCT_H_
