// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/DrivingLaneStatus.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/driving_lane_status__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x23, 0x41, 0x12, 0x8d, 0xc8, 0xbb, 0xd2, 0x01,
      0x6f, 0xe0, 0x50, 0x7d, 0x45, 0x6b, 0x64, 0x00,
      0x3f, 0xe4, 0x9e, 0xfc, 0x4c, 0x7c, 0xe0, 0x05,
      0x5f, 0x20, 0xa9, 0x96, 0xcd, 0x54, 0x02, 0x30,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/DrivingLaneStatus";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__FIELD_NAME__value[] = "value";
static char etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__FIELD_NAME__bits_unused[] = "bits_unused";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__FIELD_NAME__bits_unused, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__TYPE_NAME, 43, 43},
      {etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE indicates whether a driving lane is open to traffic.\n"
  "#  * \n"
  "#  * A lane is counted from inside border of the road excluding the hard shoulder. The size of the bit string shall\n"
  "#  * correspond to the total number of the driving lanes in the carriageway.\n"
  "#  * \n"
  "#  * The numbering is matched to @ref LanePosition.\n"
  "#  * The bit `0` is used to indicate the innermost lane, bit `1` is used to indicate the second lane from inside border.\n"
  "#  * \n"
  "#  * If a lane is closed to traffic, the corresponding bit shall be set to `1`. Otherwise, it shall be set to `0`.\n"
  "#  * \n"
  "#  * @note: hard shoulder status is not provided by this DE but in @ref HardShoulderStatus.\n"
  "#  * \n"
  "#  * @category: Traffic information\n"
  "#  * @revision: V1.3.1\n"
  "#  */\n"
  "# DrivingLaneStatus ::= BIT STRING (SIZE (1..13))\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8[] value\n"
  "uint8 bits_unused\n"
  "uint8 MIN_SIZE_BITS = 1\n"
  "uint8 MAX_SIZE_BITS = 13\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__TYPE_NAME, 43, 43},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2757, 2757},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__DrivingLaneStatus__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
