// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/HazardousLocationSurfaceConditionSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/hazardous_location_surface_condition_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xd3, 0x3a, 0x4e, 0x92, 0x5b, 0x21, 0x7f, 0xa1,
      0x91, 0x1a, 0x31, 0xf6, 0xc1, 0x77, 0xeb, 0x85,
      0x72, 0x00, 0x70, 0xec, 0xf6, 0x54, 0xb7, 0xaf,
      0x16, 0x7f, 0xfb, 0x14, 0xde, 0xa8, 0x72, 0x4e,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/HazardousLocationSurfaceConditionSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__TYPE_NAME, 71, 71},
      {etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the value of the sub cause code of the @ref CauseCode `hazardousLocation-SurfaceCondition`. \n"
  "#  * \n"
  "# The value shall be set to:\n"
  "#  * - 0  - `unavailable`     - in case further detailed information on the road surface condition is unavailable,\n"
  "#  * - 1  - `rockfalls`       - in case rock falls are detected on the road surface,\n"
  "#  * - 2  - `earthquakeDamage`- in case the road surface is damaged by earthquake,\n"
  "#  * - 3  - `sewerCollapse`   - in case of sewer collapse on the road surface,\n"
  "#  * - 4  - `subsidence`      - in case road surface is damaged by subsidence,\n"
  "#  * - 5  - `snowDrifts`      - in case road surface is damaged due to snow drift,\n"
  "#  * - 6  - `stormDamage`     - in case road surface is damaged by strong storm,\n"
  "#  * - 7  - `burstPipe`       - in case road surface is damaged due to pipe burst,\n"
  "#  * - 8  - `volcanoEruption` - in case road surface is damaged due to volcano eruption,\n"
  "#  * - 9  - `fallingIce`      - in case road surface damage is due to falling ice,\n"
  "#  * - 10 - `fire`            - in case there is fire on or near to the road surface.\n"
  "#  * - 11-255                 - are reserved for future usage.\n"
  "#  *\n"
  "#  * @category: Traffic information\n"
  "#  * @revision: V1.3.1\n"
  "#  */\n"
  "# HazardousLocation-SurfaceConditionSubCauseCode ::= INTEGER {\n"
  "#     unavailable      (0), \n"
  "#     rockfalls        (1), \n"
  "#     earthquakeDamage (2), \n"
  "#     sewerCollapse    (3), \n"
  "#     subsidence       (4), \n"
  "#     snowDrifts       (5), \n"
  "#     stormDamage      (6), \n"
  "#     burstPipe        (7), \n"
  "#     volcanoEruption  (8), \n"
  "#     fallingIce       (9), \n"
  "#     fire             (10)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 ROCKFALLS = 1\n"
  "uint8 EARTHQUAKE_DAMAGE = 2\n"
  "uint8 SEWER_COLLAPSE = 3\n"
  "uint8 SUBSIDENCE = 4\n"
  "uint8 SNOW_DRIFTS = 5\n"
  "uint8 STORM_DAMAGE = 6\n"
  "uint8 BURST_PIPE = 7\n"
  "uint8 VOLCANO_ERUPTION = 8\n"
  "uint8 FALLING_ICE = 9\n"
  "uint8 FIRE = 10\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__TYPE_NAME, 71, 71},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3806, 3806},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__HazardousLocationSurfaceConditionSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
