// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/HeightLonCarr.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/height_lon_carr__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__HeightLonCarr__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x71, 0xb9, 0xd3, 0x69, 0xc3, 0x72, 0x46, 0x31,
      0x29, 0xd5, 0x73, 0x7b, 0x66, 0x46, 0x4a, 0xc5,
      0x38, 0x83, 0x02, 0x6c, 0xca, 0x00, 0x4d, 0x52,
      0x68, 0xf1, 0x7c, 0x87, 0xbe, 0x4f, 0xd6, 0x79,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__HeightLonCarr__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/HeightLonCarr";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__HeightLonCarr__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__HeightLonCarr__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__HeightLonCarr__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__HeightLonCarr__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__HeightLonCarr__TYPE_NAME, 39, 39},
      {etsi_its_denm_ts_msgs__msg__HeightLonCarr__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the height of the left or right longitude carrier of vehicle from base to top (left or right carrier seen from vehicle\n"
  "#  * rear to front). \n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - `n` (`n >= 1` and `n < 99`) if the height information is equal to or less than n x 0,01 metre and more than (n-1) x 0,01 metre,\n"
  "#  * - `99` if the height is out of range, i.e. equal to or greater than 0,98 m,\n"
  "#  * - `100` if the height information is not available.\n"
  "#  *\n"
  "#  * @unit 0,01 metre\n"
  "#  * @category Vehicle information\n"
  "#  * @revision: Description revised in V2.1.1 (the definition of 99 has changed slightly) \n"
  "#  */\n"
  "# HeightLonCarr ::= INTEGER {\n"
  "#     outOfRange(99),\n"
  "#     unavailable(100)\n"
  "# } (1..100)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 1\n"
  "uint8 MAX = 100\n"
  "uint8 OUT_OF_RANGE = 99\n"
  "uint8 UNAVAILABLE = 100\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__HeightLonCarr__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__HeightLonCarr__TYPE_NAME, 39, 39},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2704, 2704},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__HeightLonCarr__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__HeightLonCarr__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
