// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/ImpactReductionContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/impact_reduction_container.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__IMPACT_REDUCTION_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__IMPACT_REDUCTION_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'height_lon_carr_left'
// Member 'height_lon_carr_right'
#include "etsi_its_denm_ts_msgs/msg/detail/height_lon_carr__struct.hpp"
// Member 'pos_lon_carr_left'
// Member 'pos_lon_carr_right'
#include "etsi_its_denm_ts_msgs/msg/detail/pos_lon_carr__struct.hpp"
// Member 'position_of_pillars'
#include "etsi_its_denm_ts_msgs/msg/detail/position_of_pillars__struct.hpp"
// Member 'pos_cent_mass'
#include "etsi_its_denm_ts_msgs/msg/detail/pos_cent_mass__struct.hpp"
// Member 'wheel_base_vehicle'
#include "etsi_its_denm_ts_msgs/msg/detail/wheel_base_vehicle__struct.hpp"
// Member 'turning_radius'
#include "etsi_its_denm_ts_msgs/msg/detail/turning_radius__struct.hpp"
// Member 'pos_front_ax'
#include "etsi_its_denm_ts_msgs/msg/detail/pos_front_ax__struct.hpp"
// Member 'position_of_occupants'
#include "etsi_its_denm_ts_msgs/msg/detail/position_of_occupants__struct.hpp"
// Member 'vehicle_mass'
#include "etsi_its_denm_ts_msgs/msg/detail/vehicle_mass__struct.hpp"
// Member 'request_response_indication'
#include "etsi_its_denm_ts_msgs/msg/detail/request_response_indication__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__ImpactReductionContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__ImpactReductionContainer __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ImpactReductionContainer_
{
  using Type = ImpactReductionContainer_<ContainerAllocator>;

  explicit ImpactReductionContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : height_lon_carr_left(_init),
    height_lon_carr_right(_init),
    pos_lon_carr_left(_init),
    pos_lon_carr_right(_init),
    position_of_pillars(_init),
    pos_cent_mass(_init),
    wheel_base_vehicle(_init),
    turning_radius(_init),
    pos_front_ax(_init),
    position_of_occupants(_init),
    vehicle_mass(_init),
    request_response_indication(_init)
  {
    (void)_init;
  }

  explicit ImpactReductionContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : height_lon_carr_left(_alloc, _init),
    height_lon_carr_right(_alloc, _init),
    pos_lon_carr_left(_alloc, _init),
    pos_lon_carr_right(_alloc, _init),
    position_of_pillars(_alloc, _init),
    pos_cent_mass(_alloc, _init),
    wheel_base_vehicle(_alloc, _init),
    turning_radius(_alloc, _init),
    pos_front_ax(_alloc, _init),
    position_of_occupants(_alloc, _init),
    vehicle_mass(_alloc, _init),
    request_response_indication(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _height_lon_carr_left_type =
    etsi_its_denm_ts_msgs::msg::HeightLonCarr_<ContainerAllocator>;
  _height_lon_carr_left_type height_lon_carr_left;
  using _height_lon_carr_right_type =
    etsi_its_denm_ts_msgs::msg::HeightLonCarr_<ContainerAllocator>;
  _height_lon_carr_right_type height_lon_carr_right;
  using _pos_lon_carr_left_type =
    etsi_its_denm_ts_msgs::msg::PosLonCarr_<ContainerAllocator>;
  _pos_lon_carr_left_type pos_lon_carr_left;
  using _pos_lon_carr_right_type =
    etsi_its_denm_ts_msgs::msg::PosLonCarr_<ContainerAllocator>;
  _pos_lon_carr_right_type pos_lon_carr_right;
  using _position_of_pillars_type =
    etsi_its_denm_ts_msgs::msg::PositionOfPillars_<ContainerAllocator>;
  _position_of_pillars_type position_of_pillars;
  using _pos_cent_mass_type =
    etsi_its_denm_ts_msgs::msg::PosCentMass_<ContainerAllocator>;
  _pos_cent_mass_type pos_cent_mass;
  using _wheel_base_vehicle_type =
    etsi_its_denm_ts_msgs::msg::WheelBaseVehicle_<ContainerAllocator>;
  _wheel_base_vehicle_type wheel_base_vehicle;
  using _turning_radius_type =
    etsi_its_denm_ts_msgs::msg::TurningRadius_<ContainerAllocator>;
  _turning_radius_type turning_radius;
  using _pos_front_ax_type =
    etsi_its_denm_ts_msgs::msg::PosFrontAx_<ContainerAllocator>;
  _pos_front_ax_type pos_front_ax;
  using _position_of_occupants_type =
    etsi_its_denm_ts_msgs::msg::PositionOfOccupants_<ContainerAllocator>;
  _position_of_occupants_type position_of_occupants;
  using _vehicle_mass_type =
    etsi_its_denm_ts_msgs::msg::VehicleMass_<ContainerAllocator>;
  _vehicle_mass_type vehicle_mass;
  using _request_response_indication_type =
    etsi_its_denm_ts_msgs::msg::RequestResponseIndication_<ContainerAllocator>;
  _request_response_indication_type request_response_indication;

  // setters for named parameter idiom
  Type & set__height_lon_carr_left(
    const etsi_its_denm_ts_msgs::msg::HeightLonCarr_<ContainerAllocator> & _arg)
  {
    this->height_lon_carr_left = _arg;
    return *this;
  }
  Type & set__height_lon_carr_right(
    const etsi_its_denm_ts_msgs::msg::HeightLonCarr_<ContainerAllocator> & _arg)
  {
    this->height_lon_carr_right = _arg;
    return *this;
  }
  Type & set__pos_lon_carr_left(
    const etsi_its_denm_ts_msgs::msg::PosLonCarr_<ContainerAllocator> & _arg)
  {
    this->pos_lon_carr_left = _arg;
    return *this;
  }
  Type & set__pos_lon_carr_right(
    const etsi_its_denm_ts_msgs::msg::PosLonCarr_<ContainerAllocator> & _arg)
  {
    this->pos_lon_carr_right = _arg;
    return *this;
  }
  Type & set__position_of_pillars(
    const etsi_its_denm_ts_msgs::msg::PositionOfPillars_<ContainerAllocator> & _arg)
  {
    this->position_of_pillars = _arg;
    return *this;
  }
  Type & set__pos_cent_mass(
    const etsi_its_denm_ts_msgs::msg::PosCentMass_<ContainerAllocator> & _arg)
  {
    this->pos_cent_mass = _arg;
    return *this;
  }
  Type & set__wheel_base_vehicle(
    const etsi_its_denm_ts_msgs::msg::WheelBaseVehicle_<ContainerAllocator> & _arg)
  {
    this->wheel_base_vehicle = _arg;
    return *this;
  }
  Type & set__turning_radius(
    const etsi_its_denm_ts_msgs::msg::TurningRadius_<ContainerAllocator> & _arg)
  {
    this->turning_radius = _arg;
    return *this;
  }
  Type & set__pos_front_ax(
    const etsi_its_denm_ts_msgs::msg::PosFrontAx_<ContainerAllocator> & _arg)
  {
    this->pos_front_ax = _arg;
    return *this;
  }
  Type & set__position_of_occupants(
    const etsi_its_denm_ts_msgs::msg::PositionOfOccupants_<ContainerAllocator> & _arg)
  {
    this->position_of_occupants = _arg;
    return *this;
  }
  Type & set__vehicle_mass(
    const etsi_its_denm_ts_msgs::msg::VehicleMass_<ContainerAllocator> & _arg)
  {
    this->vehicle_mass = _arg;
    return *this;
  }
  Type & set__request_response_indication(
    const etsi_its_denm_ts_msgs::msg::RequestResponseIndication_<ContainerAllocator> & _arg)
  {
    this->request_response_indication = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__ImpactReductionContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__ImpactReductionContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ImpactReductionContainer_ & other) const
  {
    if (this->height_lon_carr_left != other.height_lon_carr_left) {
      return false;
    }
    if (this->height_lon_carr_right != other.height_lon_carr_right) {
      return false;
    }
    if (this->pos_lon_carr_left != other.pos_lon_carr_left) {
      return false;
    }
    if (this->pos_lon_carr_right != other.pos_lon_carr_right) {
      return false;
    }
    if (this->position_of_pillars != other.position_of_pillars) {
      return false;
    }
    if (this->pos_cent_mass != other.pos_cent_mass) {
      return false;
    }
    if (this->wheel_base_vehicle != other.wheel_base_vehicle) {
      return false;
    }
    if (this->turning_radius != other.turning_radius) {
      return false;
    }
    if (this->pos_front_ax != other.pos_front_ax) {
      return false;
    }
    if (this->position_of_occupants != other.position_of_occupants) {
      return false;
    }
    if (this->vehicle_mass != other.vehicle_mass) {
      return false;
    }
    if (this->request_response_indication != other.request_response_indication) {
      return false;
    }
    return true;
  }
  bool operator!=(const ImpactReductionContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ImpactReductionContainer_

// alias to use template instance with default allocator
using ImpactReductionContainer =
  etsi_its_denm_ts_msgs::msg::ImpactReductionContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__IMPACT_REDUCTION_CONTAINER__STRUCT_HPP_
