// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/ManagementContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/management_container.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'action_id'
#include "etsi_its_denm_ts_msgs/msg/detail/action_id__struct.hpp"
// Member 'detection_time'
// Member 'reference_time'
#include "etsi_its_denm_ts_msgs/msg/detail/timestamp_its__struct.hpp"
// Member 'termination'
#include "etsi_its_denm_ts_msgs/msg/detail/termination__struct.hpp"
// Member 'event_position'
#include "etsi_its_denm_ts_msgs/msg/detail/reference_position__struct.hpp"
// Member 'awareness_distance'
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length3b__struct.hpp"
// Member 'traffic_direction'
#include "etsi_its_denm_ts_msgs/msg/detail/traffic_direction__struct.hpp"
// Member 'validity_duration'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_second__struct.hpp"
// Member 'transmission_interval'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_time_milli_second_positive__struct.hpp"
// Member 'station_type'
#include "etsi_its_denm_ts_msgs/msg/detail/station_type__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__ManagementContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__ManagementContainer __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct ManagementContainer_
{
  using Type = ManagementContainer_<ContainerAllocator>;

  explicit ManagementContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : action_id(_init),
    detection_time(_init),
    reference_time(_init),
    termination(_init),
    event_position(_init),
    awareness_distance(_init),
    traffic_direction(_init),
    validity_duration(_init),
    transmission_interval(_init),
    station_type(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->termination_is_present = false;
      this->awareness_distance_is_present = false;
      this->traffic_direction_is_present = false;
      this->transmission_interval_is_present = false;
    }
  }

  explicit ManagementContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : action_id(_alloc, _init),
    detection_time(_alloc, _init),
    reference_time(_alloc, _init),
    termination(_alloc, _init),
    event_position(_alloc, _init),
    awareness_distance(_alloc, _init),
    traffic_direction(_alloc, _init),
    validity_duration(_alloc, _init),
    transmission_interval(_alloc, _init),
    station_type(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->termination_is_present = false;
      this->awareness_distance_is_present = false;
      this->traffic_direction_is_present = false;
      this->transmission_interval_is_present = false;
    }
  }

  // field types and members
  using _action_id_type =
    etsi_its_denm_ts_msgs::msg::ActionId_<ContainerAllocator>;
  _action_id_type action_id;
  using _detection_time_type =
    etsi_its_denm_ts_msgs::msg::TimestampIts_<ContainerAllocator>;
  _detection_time_type detection_time;
  using _reference_time_type =
    etsi_its_denm_ts_msgs::msg::TimestampIts_<ContainerAllocator>;
  _reference_time_type reference_time;
  using _termination_type =
    etsi_its_denm_ts_msgs::msg::Termination_<ContainerAllocator>;
  _termination_type termination;
  using _termination_is_present_type =
    bool;
  _termination_is_present_type termination_is_present;
  using _event_position_type =
    etsi_its_denm_ts_msgs::msg::ReferencePosition_<ContainerAllocator>;
  _event_position_type event_position;
  using _awareness_distance_type =
    etsi_its_denm_ts_msgs::msg::StandardLength3b_<ContainerAllocator>;
  _awareness_distance_type awareness_distance;
  using _awareness_distance_is_present_type =
    bool;
  _awareness_distance_is_present_type awareness_distance_is_present;
  using _traffic_direction_type =
    etsi_its_denm_ts_msgs::msg::TrafficDirection_<ContainerAllocator>;
  _traffic_direction_type traffic_direction;
  using _traffic_direction_is_present_type =
    bool;
  _traffic_direction_is_present_type traffic_direction_is_present;
  using _validity_duration_type =
    etsi_its_denm_ts_msgs::msg::DeltaTimeSecond_<ContainerAllocator>;
  _validity_duration_type validity_duration;
  using _transmission_interval_type =
    etsi_its_denm_ts_msgs::msg::DeltaTimeMilliSecondPositive_<ContainerAllocator>;
  _transmission_interval_type transmission_interval;
  using _transmission_interval_is_present_type =
    bool;
  _transmission_interval_is_present_type transmission_interval_is_present;
  using _station_type_type =
    etsi_its_denm_ts_msgs::msg::StationType_<ContainerAllocator>;
  _station_type_type station_type;

  // setters for named parameter idiom
  Type & set__action_id(
    const etsi_its_denm_ts_msgs::msg::ActionId_<ContainerAllocator> & _arg)
  {
    this->action_id = _arg;
    return *this;
  }
  Type & set__detection_time(
    const etsi_its_denm_ts_msgs::msg::TimestampIts_<ContainerAllocator> & _arg)
  {
    this->detection_time = _arg;
    return *this;
  }
  Type & set__reference_time(
    const etsi_its_denm_ts_msgs::msg::TimestampIts_<ContainerAllocator> & _arg)
  {
    this->reference_time = _arg;
    return *this;
  }
  Type & set__termination(
    const etsi_its_denm_ts_msgs::msg::Termination_<ContainerAllocator> & _arg)
  {
    this->termination = _arg;
    return *this;
  }
  Type & set__termination_is_present(
    const bool & _arg)
  {
    this->termination_is_present = _arg;
    return *this;
  }
  Type & set__event_position(
    const etsi_its_denm_ts_msgs::msg::ReferencePosition_<ContainerAllocator> & _arg)
  {
    this->event_position = _arg;
    return *this;
  }
  Type & set__awareness_distance(
    const etsi_its_denm_ts_msgs::msg::StandardLength3b_<ContainerAllocator> & _arg)
  {
    this->awareness_distance = _arg;
    return *this;
  }
  Type & set__awareness_distance_is_present(
    const bool & _arg)
  {
    this->awareness_distance_is_present = _arg;
    return *this;
  }
  Type & set__traffic_direction(
    const etsi_its_denm_ts_msgs::msg::TrafficDirection_<ContainerAllocator> & _arg)
  {
    this->traffic_direction = _arg;
    return *this;
  }
  Type & set__traffic_direction_is_present(
    const bool & _arg)
  {
    this->traffic_direction_is_present = _arg;
    return *this;
  }
  Type & set__validity_duration(
    const etsi_its_denm_ts_msgs::msg::DeltaTimeSecond_<ContainerAllocator> & _arg)
  {
    this->validity_duration = _arg;
    return *this;
  }
  Type & set__transmission_interval(
    const etsi_its_denm_ts_msgs::msg::DeltaTimeMilliSecondPositive_<ContainerAllocator> & _arg)
  {
    this->transmission_interval = _arg;
    return *this;
  }
  Type & set__transmission_interval_is_present(
    const bool & _arg)
  {
    this->transmission_interval_is_present = _arg;
    return *this;
  }
  Type & set__station_type(
    const etsi_its_denm_ts_msgs::msg::StationType_<ContainerAllocator> & _arg)
  {
    this->station_type = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint16_t VALIDITY_DURATION_DEFAULT =
    600u;

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__ManagementContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__ManagementContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::ManagementContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const ManagementContainer_ & other) const
  {
    if (this->action_id != other.action_id) {
      return false;
    }
    if (this->detection_time != other.detection_time) {
      return false;
    }
    if (this->reference_time != other.reference_time) {
      return false;
    }
    if (this->termination != other.termination) {
      return false;
    }
    if (this->termination_is_present != other.termination_is_present) {
      return false;
    }
    if (this->event_position != other.event_position) {
      return false;
    }
    if (this->awareness_distance != other.awareness_distance) {
      return false;
    }
    if (this->awareness_distance_is_present != other.awareness_distance_is_present) {
      return false;
    }
    if (this->traffic_direction != other.traffic_direction) {
      return false;
    }
    if (this->traffic_direction_is_present != other.traffic_direction_is_present) {
      return false;
    }
    if (this->validity_duration != other.validity_duration) {
      return false;
    }
    if (this->transmission_interval != other.transmission_interval) {
      return false;
    }
    if (this->transmission_interval_is_present != other.transmission_interval_is_present) {
      return false;
    }
    if (this->station_type != other.station_type) {
      return false;
    }
    return true;
  }
  bool operator!=(const ManagementContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct ManagementContainer_

// alias to use template instance with default allocator
using ManagementContainer =
  etsi_its_denm_ts_msgs::msg::ManagementContainer_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint16_t ManagementContainer_<ContainerAllocator>::VALIDITY_DURATION_DEFAULT;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__MANAGEMENT_CONTAINER__STRUCT_HPP_
