// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/PathId.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/path_id.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_ID__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_ID__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__PathId __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__PathId __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PathId_
{
  using Type = PathId_<ContainerAllocator>;

  explicit PathId_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  explicit PathId_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    (void)_alloc;
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->value = 0;
    }
  }

  // field types and members
  using _value_type =
    uint8_t;
  _value_type value;

  // setters for named parameter idiom
  Type & set__value(
    const uint8_t & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations
  static constexpr uint8_t MIN =
    0u;
  static constexpr uint8_t MAX =
    14u;
  static constexpr uint8_t NO_PATH =
    0u;
  static constexpr uint8_t PATH1 =
    1u;
  static constexpr uint8_t PATH2 =
    2u;
  static constexpr uint8_t PATH3 =
    3u;
  static constexpr uint8_t PATH4 =
    4u;
  static constexpr uint8_t PATH5 =
    5u;
  static constexpr uint8_t PATH6 =
    6u;
  static constexpr uint8_t PATH7 =
    7u;
  static constexpr uint8_t PATH_EXTENDED1 =
    8u;
  static constexpr uint8_t PATH_EXTENDED2 =
    9u;
  static constexpr uint8_t PATH_EXTENDED3 =
    10u;
  static constexpr uint8_t PATH_EXTENDED4 =
    11u;
  static constexpr uint8_t PATH_EXTENDED5 =
    12u;
  static constexpr uint8_t PATH_EXTENDED6 =
    13u;
  static constexpr uint8_t PATH_EXTENDED7 =
    14u;

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__PathId
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__PathId
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::PathId_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PathId_ & other) const
  {
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const PathId_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PathId_

// alias to use template instance with default allocator
using PathId =
  etsi_its_denm_ts_msgs::msg::PathId_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::MIN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::MAX;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::NO_PATH;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH4;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH5;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH6;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH7;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH_EXTENDED1;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH_EXTENDED2;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH_EXTENDED3;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH_EXTENDED4;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH_EXTENDED5;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH_EXTENDED6;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr uint8_t PathId_<ContainerAllocator>::PATH_EXTENDED7;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__PATH_ID__STRUCT_HPP_
