// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/PosLonCarr.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/pos_lon_carr__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__PosLonCarr__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xfe, 0x0d, 0x10, 0xe6, 0x4c, 0x34, 0x96, 0xf0,
      0xc8, 0xf8, 0xc2, 0xd7, 0x56, 0x53, 0x36, 0x84,
      0x4f, 0x77, 0x40, 0xe6, 0xd0, 0x6c, 0xe6, 0xee,
      0x73, 0xa2, 0xba, 0x67, 0x91, 0x3b, 0x65, 0xac,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__PosLonCarr__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/PosLonCarr";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__PosLonCarr__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__PosLonCarr__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__PosLonCarr__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__PosLonCarr__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__PosLonCarr__TYPE_NAME, 36, 36},
      {etsi_its_denm_ts_msgs__msg__PosLonCarr__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the distance from the centre of vehicle front bumper to the right or left longitudinal carrier of vehicle.\n"
  "#  * The left/right carrier refers to the left/right as seen from a passenger sitting in the vehicle.\n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - `n` (`n > 0` and `n < 126`) for any aplicable value between 0,01 metre and 1,26 metres, \n"
  "#  * - `126` for values equal to or higher than 1.25 metres,\n"
  "#  * - `127` if the information is unavailable.\n"
  "#  *\n"
  "#  * @unit 0,01 metre \n"
  "#  * @category Vehicle information\n"
  "#  * @revision: description revised in V2.1.1 (the meaning of 126 has changed slightly) \n"
  "#  */\n"
  "# PosLonCarr ::= INTEGER {\n"
  "#     outOfRange  (126),\n"
  "#     unavailable (127)\n"
  "# } (1..127)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 1\n"
  "uint8 MAX = 127\n"
  "uint8 OUT_OF_RANGE = 126\n"
  "uint8 UNAVAILABLE = 127\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__PosLonCarr__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__PosLonCarr__TYPE_NAME, 36, 36},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2705, 2705},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__PosLonCarr__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__PosLonCarr__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
