// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/SituationContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/situation_container.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__SITUATION_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__SITUATION_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'information_quality'
#include "etsi_its_denm_ts_msgs/msg/detail/information_quality__struct.hpp"
// Member 'event_type'
// Member 'linked_cause'
#include "etsi_its_denm_ts_msgs/msg/detail/cause_code_v2__struct.hpp"
// Member 'event_zone'
#include "etsi_its_denm_ts_msgs/msg/detail/event_zone__struct.hpp"
// Member 'linked_denms'
#include "etsi_its_denm_ts_msgs/msg/detail/action_id_list__struct.hpp"
// Member 'event_end'
#include "etsi_its_denm_ts_msgs/msg/detail/position1d__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__SituationContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__SituationContainer __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct SituationContainer_
{
  using Type = SituationContainer_<ContainerAllocator>;

  explicit SituationContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : information_quality(_init),
    event_type(_init),
    linked_cause(_init),
    event_zone(_init),
    linked_denms(_init),
    event_end(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->linked_cause_is_present = false;
      this->event_zone_is_present = false;
      this->linked_denms_is_present = false;
      this->event_end_is_present = false;
    }
  }

  explicit SituationContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : information_quality(_alloc, _init),
    event_type(_alloc, _init),
    linked_cause(_alloc, _init),
    event_zone(_alloc, _init),
    linked_denms(_alloc, _init),
    event_end(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->linked_cause_is_present = false;
      this->event_zone_is_present = false;
      this->linked_denms_is_present = false;
      this->event_end_is_present = false;
    }
  }

  // field types and members
  using _information_quality_type =
    etsi_its_denm_ts_msgs::msg::InformationQuality_<ContainerAllocator>;
  _information_quality_type information_quality;
  using _event_type_type =
    etsi_its_denm_ts_msgs::msg::CauseCodeV2_<ContainerAllocator>;
  _event_type_type event_type;
  using _linked_cause_type =
    etsi_its_denm_ts_msgs::msg::CauseCodeV2_<ContainerAllocator>;
  _linked_cause_type linked_cause;
  using _linked_cause_is_present_type =
    bool;
  _linked_cause_is_present_type linked_cause_is_present;
  using _event_zone_type =
    etsi_its_denm_ts_msgs::msg::EventZone_<ContainerAllocator>;
  _event_zone_type event_zone;
  using _event_zone_is_present_type =
    bool;
  _event_zone_is_present_type event_zone_is_present;
  using _linked_denms_type =
    etsi_its_denm_ts_msgs::msg::ActionIdList_<ContainerAllocator>;
  _linked_denms_type linked_denms;
  using _linked_denms_is_present_type =
    bool;
  _linked_denms_is_present_type linked_denms_is_present;
  using _event_end_type =
    etsi_its_denm_ts_msgs::msg::Position1d_<ContainerAllocator>;
  _event_end_type event_end;
  using _event_end_is_present_type =
    bool;
  _event_end_is_present_type event_end_is_present;

  // setters for named parameter idiom
  Type & set__information_quality(
    const etsi_its_denm_ts_msgs::msg::InformationQuality_<ContainerAllocator> & _arg)
  {
    this->information_quality = _arg;
    return *this;
  }
  Type & set__event_type(
    const etsi_its_denm_ts_msgs::msg::CauseCodeV2_<ContainerAllocator> & _arg)
  {
    this->event_type = _arg;
    return *this;
  }
  Type & set__linked_cause(
    const etsi_its_denm_ts_msgs::msg::CauseCodeV2_<ContainerAllocator> & _arg)
  {
    this->linked_cause = _arg;
    return *this;
  }
  Type & set__linked_cause_is_present(
    const bool & _arg)
  {
    this->linked_cause_is_present = _arg;
    return *this;
  }
  Type & set__event_zone(
    const etsi_its_denm_ts_msgs::msg::EventZone_<ContainerAllocator> & _arg)
  {
    this->event_zone = _arg;
    return *this;
  }
  Type & set__event_zone_is_present(
    const bool & _arg)
  {
    this->event_zone_is_present = _arg;
    return *this;
  }
  Type & set__linked_denms(
    const etsi_its_denm_ts_msgs::msg::ActionIdList_<ContainerAllocator> & _arg)
  {
    this->linked_denms = _arg;
    return *this;
  }
  Type & set__linked_denms_is_present(
    const bool & _arg)
  {
    this->linked_denms_is_present = _arg;
    return *this;
  }
  Type & set__event_end(
    const etsi_its_denm_ts_msgs::msg::Position1d_<ContainerAllocator> & _arg)
  {
    this->event_end = _arg;
    return *this;
  }
  Type & set__event_end_is_present(
    const bool & _arg)
  {
    this->event_end_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__SituationContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__SituationContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::SituationContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SituationContainer_ & other) const
  {
    if (this->information_quality != other.information_quality) {
      return false;
    }
    if (this->event_type != other.event_type) {
      return false;
    }
    if (this->linked_cause != other.linked_cause) {
      return false;
    }
    if (this->linked_cause_is_present != other.linked_cause_is_present) {
      return false;
    }
    if (this->event_zone != other.event_zone) {
      return false;
    }
    if (this->event_zone_is_present != other.event_zone_is_present) {
      return false;
    }
    if (this->linked_denms != other.linked_denms) {
      return false;
    }
    if (this->linked_denms_is_present != other.linked_denms_is_present) {
      return false;
    }
    if (this->event_end != other.event_end) {
      return false;
    }
    if (this->event_end_is_present != other.event_end_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const SituationContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SituationContainer_

// alias to use template instance with default allocator
using SituationContainer =
  etsi_its_denm_ts_msgs::msg::SituationContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__SITUATION_CONTAINER__STRUCT_HPP_
