// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/SlowVehicleSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/slow_vehicle_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xf2, 0x8e, 0xd8, 0x75, 0x70, 0xe1, 0xbc, 0xd6,
      0x12, 0xab, 0xd9, 0x96, 0x7f, 0xcd, 0xc0, 0x8e,
      0x01, 0x9d, 0x1e, 0x15, 0x1e, 0x37, 0x19, 0x42,
      0xb6, 0x45, 0x10, 0x61, 0xc3, 0xe4, 0xd9, 0x23,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/SlowVehicleSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__TYPE_NAME, 49, 49},
      {etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the sub cause codes of the @ref CauseCode \"slowVehicle\".\n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - 0 `unavailable`                    - in case further detailed information on slow vehicle driving event is\n"
  "#  *                                        unavailable,\n"
  "#  * - 1 `maintenanceVehicle`             - in case of a slow driving maintenance vehicle on the road,\n"
  "#  * - 2 `vehiclesSlowingToLookAtAccident`- in case vehicle is temporally slowing down to look at accident, spot, etc.,\n"
  "#  * - 3 `abnormalLoad`                   - in case an abnormal loaded vehicle is driving slowly on the road,\n"
  "#  * - 4 `abnormalWideLoad`               - in case an abnormal wide load vehicle is driving slowly on the road,\n"
  "#  * - 5 `convoy`                         - in case of slow driving convoy on the road,\n"
  "#  * - 6 `snowplough`                     - in case of slow driving snow plough on the road,\n"
  "#  * - 7 `deicing`                        - in case of slow driving de-icing vehicle on the road,\n"
  "#  * - 8 `saltingVehicles`                - in case of slow driving salting vehicle on the road.\n"
  "#  * - 9-255                              - are reserved for future usage.\n"
  "#  * \n"
  "#  * @category: Traffic information\n"
  "#  * @revision: V1.3.1\n"
  "#  */\n"
  "# SlowVehicleSubCauseCode ::= INTEGER {\n"
  "#     unavailable                     (0), \n"
  "#     maintenanceVehicle              (1), \n"
  "#     vehiclesSlowingToLookAtAccident (2), \n"
  "#     abnormalLoad                    (3), \n"
  "#     abnormalWideLoad                (4), \n"
  "#     convoy                          (5), \n"
  "#     snowplough                      (6), \n"
  "#     deicing                         (7), \n"
  "#     saltingVehicles                 (8)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 MAINTENANCE_VEHICLE = 1\n"
  "uint8 VEHICLES_SLOWING_TO_LOOK_AT_ACCIDENT = 2\n"
  "uint8 ABNORMAL_LOAD = 3\n"
  "uint8 ABNORMAL_WIDE_LOAD = 4\n"
  "uint8 CONVOY = 5\n"
  "uint8 SNOWPLOUGH = 6\n"
  "uint8 DEICING = 7\n"
  "uint8 SALTING_VEHICLES = 8\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__TYPE_NAME, 49, 49},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3874, 3874},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__SlowVehicleSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
