// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from etsi_its_denm_ts_msgs:msg/StationaryVehicleContainer.idl
// generated code does not contain a copyright notice
#include "etsi_its_denm_ts_msgs/msg/detail/stationary_vehicle_container__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `stationary_since`
#include "etsi_its_denm_ts_msgs/msg/detail/stationary_since__functions.h"
// Member `stationary_cause`
#include "etsi_its_denm_ts_msgs/msg/detail/cause_code_v2__functions.h"
// Member `carrying_dangerous_goods`
#include "etsi_its_denm_ts_msgs/msg/detail/dangerous_goods_extended__functions.h"
// Member `number_of_occupants`
#include "etsi_its_denm_ts_msgs/msg/detail/number_of_occupants__functions.h"
// Member `vehicle_identification`
#include "etsi_its_denm_ts_msgs/msg/detail/vehicle_identification__functions.h"
// Member `energy_storage_type`
#include "etsi_its_denm_ts_msgs/msg/detail/energy_storage_type__functions.h"

bool
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__init(etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer * msg)
{
  if (!msg) {
    return false;
  }
  // stationary_since
  if (!etsi_its_denm_ts_msgs__msg__StationarySince__init(&msg->stationary_since)) {
    etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__fini(msg);
    return false;
  }
  // stationary_since_is_present
  // stationary_cause
  if (!etsi_its_denm_ts_msgs__msg__CauseCodeV2__init(&msg->stationary_cause)) {
    etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__fini(msg);
    return false;
  }
  // stationary_cause_is_present
  // carrying_dangerous_goods
  if (!etsi_its_denm_ts_msgs__msg__DangerousGoodsExtended__init(&msg->carrying_dangerous_goods)) {
    etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__fini(msg);
    return false;
  }
  // carrying_dangerous_goods_is_present
  // number_of_occupants
  if (!etsi_its_denm_ts_msgs__msg__NumberOfOccupants__init(&msg->number_of_occupants)) {
    etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__fini(msg);
    return false;
  }
  // number_of_occupants_is_present
  // vehicle_identification
  if (!etsi_its_denm_ts_msgs__msg__VehicleIdentification__init(&msg->vehicle_identification)) {
    etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__fini(msg);
    return false;
  }
  // vehicle_identification_is_present
  // energy_storage_type
  if (!etsi_its_denm_ts_msgs__msg__EnergyStorageType__init(&msg->energy_storage_type)) {
    etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__fini(msg);
    return false;
  }
  // energy_storage_type_is_present
  return true;
}

void
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__fini(etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer * msg)
{
  if (!msg) {
    return;
  }
  // stationary_since
  etsi_its_denm_ts_msgs__msg__StationarySince__fini(&msg->stationary_since);
  // stationary_since_is_present
  // stationary_cause
  etsi_its_denm_ts_msgs__msg__CauseCodeV2__fini(&msg->stationary_cause);
  // stationary_cause_is_present
  // carrying_dangerous_goods
  etsi_its_denm_ts_msgs__msg__DangerousGoodsExtended__fini(&msg->carrying_dangerous_goods);
  // carrying_dangerous_goods_is_present
  // number_of_occupants
  etsi_its_denm_ts_msgs__msg__NumberOfOccupants__fini(&msg->number_of_occupants);
  // number_of_occupants_is_present
  // vehicle_identification
  etsi_its_denm_ts_msgs__msg__VehicleIdentification__fini(&msg->vehicle_identification);
  // vehicle_identification_is_present
  // energy_storage_type
  etsi_its_denm_ts_msgs__msg__EnergyStorageType__fini(&msg->energy_storage_type);
  // energy_storage_type_is_present
}

bool
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__are_equal(const etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer * lhs, const etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // stationary_since
  if (!etsi_its_denm_ts_msgs__msg__StationarySince__are_equal(
      &(lhs->stationary_since), &(rhs->stationary_since)))
  {
    return false;
  }
  // stationary_since_is_present
  if (lhs->stationary_since_is_present != rhs->stationary_since_is_present) {
    return false;
  }
  // stationary_cause
  if (!etsi_its_denm_ts_msgs__msg__CauseCodeV2__are_equal(
      &(lhs->stationary_cause), &(rhs->stationary_cause)))
  {
    return false;
  }
  // stationary_cause_is_present
  if (lhs->stationary_cause_is_present != rhs->stationary_cause_is_present) {
    return false;
  }
  // carrying_dangerous_goods
  if (!etsi_its_denm_ts_msgs__msg__DangerousGoodsExtended__are_equal(
      &(lhs->carrying_dangerous_goods), &(rhs->carrying_dangerous_goods)))
  {
    return false;
  }
  // carrying_dangerous_goods_is_present
  if (lhs->carrying_dangerous_goods_is_present != rhs->carrying_dangerous_goods_is_present) {
    return false;
  }
  // number_of_occupants
  if (!etsi_its_denm_ts_msgs__msg__NumberOfOccupants__are_equal(
      &(lhs->number_of_occupants), &(rhs->number_of_occupants)))
  {
    return false;
  }
  // number_of_occupants_is_present
  if (lhs->number_of_occupants_is_present != rhs->number_of_occupants_is_present) {
    return false;
  }
  // vehicle_identification
  if (!etsi_its_denm_ts_msgs__msg__VehicleIdentification__are_equal(
      &(lhs->vehicle_identification), &(rhs->vehicle_identification)))
  {
    return false;
  }
  // vehicle_identification_is_present
  if (lhs->vehicle_identification_is_present != rhs->vehicle_identification_is_present) {
    return false;
  }
  // energy_storage_type
  if (!etsi_its_denm_ts_msgs__msg__EnergyStorageType__are_equal(
      &(lhs->energy_storage_type), &(rhs->energy_storage_type)))
  {
    return false;
  }
  // energy_storage_type_is_present
  if (lhs->energy_storage_type_is_present != rhs->energy_storage_type_is_present) {
    return false;
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__copy(
  const etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer * input,
  etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer * output)
{
  if (!input || !output) {
    return false;
  }
  // stationary_since
  if (!etsi_its_denm_ts_msgs__msg__StationarySince__copy(
      &(input->stationary_since), &(output->stationary_since)))
  {
    return false;
  }
  // stationary_since_is_present
  output->stationary_since_is_present = input->stationary_since_is_present;
  // stationary_cause
  if (!etsi_its_denm_ts_msgs__msg__CauseCodeV2__copy(
      &(input->stationary_cause), &(output->stationary_cause)))
  {
    return false;
  }
  // stationary_cause_is_present
  output->stationary_cause_is_present = input->stationary_cause_is_present;
  // carrying_dangerous_goods
  if (!etsi_its_denm_ts_msgs__msg__DangerousGoodsExtended__copy(
      &(input->carrying_dangerous_goods), &(output->carrying_dangerous_goods)))
  {
    return false;
  }
  // carrying_dangerous_goods_is_present
  output->carrying_dangerous_goods_is_present = input->carrying_dangerous_goods_is_present;
  // number_of_occupants
  if (!etsi_its_denm_ts_msgs__msg__NumberOfOccupants__copy(
      &(input->number_of_occupants), &(output->number_of_occupants)))
  {
    return false;
  }
  // number_of_occupants_is_present
  output->number_of_occupants_is_present = input->number_of_occupants_is_present;
  // vehicle_identification
  if (!etsi_its_denm_ts_msgs__msg__VehicleIdentification__copy(
      &(input->vehicle_identification), &(output->vehicle_identification)))
  {
    return false;
  }
  // vehicle_identification_is_present
  output->vehicle_identification_is_present = input->vehicle_identification_is_present;
  // energy_storage_type
  if (!etsi_its_denm_ts_msgs__msg__EnergyStorageType__copy(
      &(input->energy_storage_type), &(output->energy_storage_type)))
  {
    return false;
  }
  // energy_storage_type_is_present
  output->energy_storage_type_is_present = input->energy_storage_type_is_present;
  return true;
}

etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer *
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer * msg = (etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer));
  bool success = etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__destroy(etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence__init(etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer * data = NULL;

  if (size) {
    data = (etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer *)allocator.zero_allocate(size, sizeof(etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence__fini(etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence *
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence * array = (etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence *)allocator.allocate(sizeof(etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence__destroy(etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence__are_equal(const etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence * lhs, const etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence__copy(
  const etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence * input,
  etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer * data =
      (etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!etsi_its_denm_ts_msgs__msg__StationaryVehicleContainer__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
