// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/TrafficDirection.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/traffic_direction__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__TrafficDirection__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x72, 0x30, 0xcc, 0x56, 0x95, 0x80, 0xa6, 0x4e,
      0xfd, 0x84, 0x31, 0x3e, 0x5e, 0x40, 0xc9, 0xc9,
      0x0f, 0xa6, 0x33, 0x50, 0x70, 0x70, 0xef, 0x7e,
      0x51, 0x0c, 0x54, 0xf5, 0x85, 0x57, 0x6c, 0xef,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__TrafficDirection__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/TrafficDirection";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__TrafficDirection__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__TrafficDirection__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__TrafficDirection__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__TrafficDirection__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__TrafficDirection__TYPE_NAME, 42, 42},
      {etsi_its_denm_ts_msgs__msg__TrafficDirection__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE indicates a direction of traffic with respect to a reference direction, and a portion of that traffic with respect to a reference position.\n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - 0 `allTrafficDirections`                                    - for all directions of traffic, \n"
  "#  * - 1 `sameAsReferenceDirection-upstreamOfReferencePosition`    - for the direction of traffic according to the reference direction, and the portion of traffic upstream of the reference position, \n"
  "#  * - 2 `sameAsReferenceDirection-downstreamOfReferencePosition`  - for the direction of traffic according to the reference direction, and the portion of traffic downstream of the reference position, \n"
  "#  * - 3 `oppositeToReferenceDirection`                            - for the direction of traffic opposite to the reference direction. \n"
  "#  *\n"
  "#  * @note: Upstream traffic corresponds to the incoming traffic towards the event position, and downstream traffic to the departing traffic away from the event position.\n"
  "#  * @category: GeoReference information\n"
  "#  * @revision: Created in V2.1.1 from RelevanceTrafficDirection, description and naming of values changed in V2.2.1\n"
  "#  *\n"
  "#  */\n"
  "#  TrafficDirection ::= ENUMERATED {\n"
  "#     allTrafficDirections(0), \n"
  "#     sameAsReferenceDirection-upstreamOfReferencePosition(1), \n"
  "#     sameAsReferenceDirection-downstreamOfReferencePosition(2), \n"
  "#     oppositeToReferenceDirection(3)\n"
  "# }\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 ALL_TRAFFIC_DIRECTIONS = 0\n"
  "uint8 SAME_AS_REFERENCE_DIRECTION_UPSTREAM_OF_REFERENCE_POSITION = 1\n"
  "uint8 SAME_AS_REFERENCE_DIRECTION_DOWNSTREAM_OF_REFERENCE_POSITION = 2\n"
  "uint8 OPPOSITE_TO_REFERENCE_DIRECTION = 3\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__TrafficDirection__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__TrafficDirection__TYPE_NAME, 42, 42},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3535, 3535},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__TrafficDirection__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__TrafficDirection__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
