// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/VehicleMass.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/vehicle_mass__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__VehicleMass__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xa1, 0x90, 0x3e, 0x54, 0x55, 0x11, 0x03, 0x1c,
      0x95, 0x8b, 0xb6, 0xb1, 0x1a, 0xc5, 0xf1, 0x1e,
      0x74, 0x91, 0xa3, 0x6d, 0xd0, 0x9d, 0xa1, 0xe5,
      0x33, 0x30, 0x4c, 0x42, 0x7d, 0x16, 0x57, 0x98,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__VehicleMass__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/VehicleMass";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__VehicleMass__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__VehicleMass__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__VehicleMass__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT16,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__VehicleMass__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__VehicleMass__TYPE_NAME, 37, 37},
      {etsi_its_denm_ts_msgs__msg__VehicleMass__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the mass of an empty loaded vehicle.\n"
  "#  *\n"
  "#  * The value shall be set to: \n"
  "#  * - `n` (`n > 0` and `n < 1023`) to indicate that the applicable value is equal to or less than n x 10^5 gramm, and greater than (n-1) x 10^5 gramm,\n"
  "#  * - `1 023` indicates that the vehicle mass is greater than 102 200 000 g,\n"
  "#  * - `1 024` indicates  the vehicle mass information is unavailable.\n"
  "#  * \n"
  "#  * @note:\\tThe empty load vehicle is defined in ISO 1176 [8], clause 4.6.\n"
  "#  * \n"
  "#  * @unit: 10^5 gramm\n"
  "#  * @category: Vehicle information\n"
  "#  * @revision: Description updated in V2.1.1 (the meaning of 1 023 has changed slightly).\n"
  "# */\n"
  "# VehicleMass ::= INTEGER {\n"
  "#     outOfRange (1023), \n"
  "#     unavailable(1024)\n"
  "# } (1..1024) \n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint16 value\n"
  "uint16 MIN = 1\n"
  "uint16 MAX = 1024\n"
  "uint16 OUT_OF_RANGE = 1023\n"
  "uint16 UNAVAILABLE = 1024\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__VehicleMass__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__VehicleMass__TYPE_NAME, 37, 37},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 2726, 2726},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__VehicleMass__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__VehicleMass__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
