// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/VruClusterProfiles.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/vru_cluster_profiles__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__VruClusterProfiles__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xff, 0xb1, 0x48, 0x78, 0x7e, 0x1b, 0xa7, 0xf6,
      0x45, 0x8d, 0x20, 0xce, 0x3c, 0xb0, 0xc5, 0xdf,
      0x65, 0x7c, 0xe5, 0x23, 0x48, 0x04, 0x08, 0xd8,
      0xed, 0xb1, 0x07, 0xe2, 0xa0, 0xa1, 0x5e, 0x9b,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__VruClusterProfiles__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/VruClusterProfiles";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__VruClusterProfiles__FIELD_NAME__value[] = "value";
static char etsi_its_denm_ts_msgs__msg__VruClusterProfiles__FIELD_NAME__bits_unused[] = "bits_unused";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__VruClusterProfiles__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__VruClusterProfiles__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {etsi_its_denm_ts_msgs__msg__VruClusterProfiles__FIELD_NAME__bits_unused, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__VruClusterProfiles__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__VruClusterProfiles__TYPE_NAME, 44, 44},
      {etsi_its_denm_ts_msgs__msg__VruClusterProfiles__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /** \n"
  "#  * This DE Identifies all the VRU profile types within a cluster.\n"
  "#  * It consist of a Bitmap encoding VRU profiles, to allow multiple profiles to be indicated in a single cluster (heterogeneous cluster if more than one profile).\n"
  "#  * \n"
  "#  * The corresponding bit shall be set to 1 under the following conditions:\n"
  "#  * - 0 `pedestrian`  - indicates that the VRU cluster contains at least one pedestrian VRU,\n"
  "#  * - 1 `bicycle`     - indicates that the VRU cluster contains at least one bicycle VRU member,\n"
  "#  * - 2 `motorcyclist`- indicates that the VRU cluster contains at least one motorcycle VRU member,\n"
  "#  * - 3 `animal`      - indicates that the VRU cluster contains at least one animal VRU member.\n"
  "#  * \n"
  "#  * Otherwise, the corresponding bit shall be set to 0.\n"
  "#  *\n"
  "#  * @category: VRU information\n"
  "#  * @revision: Created in V2.1.1\n"
  "# */\n"
  "# VruClusterProfiles ::= BIT STRING {\n"
  "#     pedestrian   (0),\n"
  "#     bicyclist    (1),\n"
  "#     motorcyclist (2),\n"
  "#     animal       (3)\n"
  "# } (SIZE(4))\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8[] value\n"
  "uint8 bits_unused\n"
  "uint8 SIZE_BITS = 4\n"
  "uint8 BIT_INDEX_PEDESTRIAN = 0\n"
  "uint8 BIT_INDEX_BICYCLIST = 1\n"
  "uint8 BIT_INDEX_MOTORCYCLIST = 2\n"
  "uint8 BIT_INDEX_ANIMAL = 3\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__VruClusterProfiles__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__VruClusterProfiles__TYPE_NAME, 44, 44},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3057, 3057},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__VruClusterProfiles__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__VruClusterProfiles__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
