// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/VruSubProfileBicyclist.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/vru_sub_profile_bicyclist__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x28, 0xb9, 0x37, 0x23, 0x0a, 0x35, 0x5a, 0xd0,
      0x4d, 0x08, 0x30, 0x82, 0xfb, 0x3a, 0xcf, 0x63,
      0x73, 0xdf, 0xf7, 0x98, 0x77, 0x44, 0xa9, 0x18,
      0x4f, 0x08, 0x95, 0xa0, 0x55, 0xf5, 0xcf, 0xaf,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/VruSubProfileBicyclist";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__TYPE_NAME, 48, 48},
      {etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE indicates the profile of a VRU and its light VRU vehicle / mounted animal. \n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - 0 `unavailable`           - to indicate that the information  is unavailable,\n"
  "#  * - 1 `bicyclist `            - to indicate a cycle and bicyclist to which no more-specific profile applies, \n"
  "#  * - 2 `wheelchair-user`       - to indicate a wheelchair and its user,\n"
  "#  * - 3 `horse-and-rider`       - to indicate a horse and rider,\n"
  "#  * - 4 `rollerskater`          - to indicate a roller-skater and skater,\n"
  "#  * - 5 `e-scooter`             - to indicate an e-scooter and rider,\n"
  "#  * - 6 `personal-transporter`  - to indicate a personal-transporter and rider,\n"
  "#  * - 7 `pedelec`               - to indicate a pedelec and rider to which no more-specific profile applies,\n"
  "#  * - 8 `speed-pedelec`         - to indicate a speed-pedelec and rider.\n"
  "#  * - 9 `roadbike`              - to indicate a road bicycle (or road pedelec) and rider,\n"
  "#  * - 10 `childrensbike`        - to indicate a children\\xef\\xbf\\xbds bicycle (or children\\xef\\xbf\\xbds pedelec) and rider,\n"
  "#  * - 11 to 15                  - are reserved for future usage. \n"
  "#  *\n"
  "#  * @category: VRU information\n"
  "#  * @revision: Created in V2.1.1, values 9 and 10 assigned in V2.2.1\n"
  "#  */\n"
  "# VruSubProfileBicyclist ::= INTEGER {\n"
  "#     unavailable          (0), \n"
  "#     bicyclist            (1), \n"
  "#     wheelchair-user      (2), \n"
  "#     horse-and-rider      (3), \n"
  "#     rollerskater         (4), \n"
  "#     e-scooter            (5), \n"
  "#     personal-transporter (6),\n"
  "#     pedelec              (7), \n"
  "#     speed-pedelec        (8),\n"
  "#     roadbike             (9),\n"
  "#     childrensbike        (10)\n"
  "# }(0..15)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 15\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 BICYCLIST = 1\n"
  "uint8 WHEELCHAIR_USER = 2\n"
  "uint8 HORSE_AND_RIDER = 3\n"
  "uint8 ROLLERSKATER = 4\n"
  "uint8 E_SCOOTER = 5\n"
  "uint8 PERSONAL_TRANSPORTER = 6\n"
  "uint8 PEDELEC = 7\n"
  "uint8 SPEED_PEDELEC = 8\n"
  "uint8 ROADBIKE = 9\n"
  "uint8 CHILDRENSBIKE = 10\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__TYPE_NAME, 48, 48},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3845, 3845},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__VruSubProfileBicyclist__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
