// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/VruSubProfileMotorcyclist.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/vru_sub_profile_motorcyclist__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xa8, 0x2c, 0xb2, 0x2c, 0x3d, 0x20, 0x95, 0x28,
      0xc0, 0xae, 0x5d, 0x2e, 0x16, 0xe3, 0x72, 0x2f,
      0xf9, 0x77, 0xbe, 0xa4, 0xbe, 0x8f, 0xbd, 0xcd,
      0x41, 0xb9, 0xdb, 0x42, 0xce, 0x41, 0x58, 0xce,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/VruSubProfileMotorcyclist";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__TYPE_NAME, 51, 51},
      {etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE indicates the profile of a motorcyclist and corresponding vehicle.\n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - 0 `unavailable `                  - to indicate that the information  is unavailable,\n"
  "#  * - 1 `moped`                         - to indicate a moped and rider,\n"
  "#  * - 2 `motorcycle`                    - to indicate a motorcycle and rider,\n"
  "#  * - 3 `motorcycle-and-sidecar-right`  - to indicate a motorcycle with sidecar on the right and rider,\n"
  "#  * - 4 `motorcycle-and-sidecar-left`   - to indicate  a motorcycle with sidecar on the left and rider.\n"
  "#  * - 5 to 15                           - are reserved for future usage. \n"
  "#  *\n"
  "#  * @category: VRU information\n"
  "#  * @revision: Created in V2.1.1, type changed from ENUMERATED to INTEGER in V2.2.1\n"
  "#  */\n"
  "# VruSubProfileMotorcyclist ::= INTEGER { \n"
  "#     unavailable                  (0), \n"
  "#     moped                        (1), \n"
  "#     motorcycle                   (2), \n"
  "#     motorcycle-and-sidecar-right (3), \n"
  "#     motorcycle-and-sidecar-left  (4)\n"
  "# }(0..15)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 15\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 MOPED = 1\n"
  "uint8 MOTORCYCLE = 2\n"
  "uint8 MOTORCYCLE_AND_SIDECAR_RIGHT = 3\n"
  "uint8 MOTORCYCLE_AND_SIDECAR_LEFT = 4\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__TYPE_NAME, 51, 51},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3103, 3103},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__VruSubProfileMotorcyclist__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
