// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/AccidentSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/accident_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xb2, 0x32, 0xd8, 0x9f, 0x95, 0x3d, 0x29, 0x22,
      0x4d, 0x0d, 0x3f, 0xd8, 0xff, 0xc7, 0x57, 0xc7,
      0xec, 0xd0, 0x02, 0xaa, 0x85, 0x50, 0xd6, 0xcb,
      0x89, 0x04, 0x95, 0xfa, 0xbf, 0xe2, 0x96, 0xc1,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/AccidentSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__TYPE_NAME, 46, 46},
      {etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the value of the sub cause code of the @ref CauseCode `accident`.\n"
  "#  *\n"
  "#  * The value shall be set to:\n"
  "#  * - 0 - `unavailable`                        - in case the information on the sub cause of the accident is unavailable,\n"
  "#  * - 1 - `multiVehicleAccident`               - in case more than two vehicles are involved in accident,\n"
  "#  * - 2 - `heavyAccident`                      - in case the airbag of the vehicle involved in the accident is triggered, \n"
  "#  *                                              the accident requires important rescue and/or recovery work,\n"
  "#  * - 3 - `accidentInvolvingLorry`             - in case the accident involves a lorry,\n"
  "#  * - 4 - `accidentInvolvingBus`               - in case the accident involves a bus,\n"
  "#  * - 5 - `accidentInvolvingHazardousMaterials`- in case the accident involves hazardous material,\n"
  "#  * - 6 - `accidentOnOppositeLane`             - in case the accident happens on opposite lanes,\n"
  "#  * - 7 - `unsecuredAccident`                  - in case the accident is not secured,\n"
  "#  * - 8 - `assistanceRequested`                - in case rescue and assistance are requested,\n"
  "#  * - 9-255                                    - reserved for future usage. \n"
  "#  *\n"
  "#  * @category: Traffic information\n"
  "#  * @revision: V1.3.1\n"
  "#  */\n"
  "# AccidentSubCauseCode ::= INTEGER {\n"
  "#     unavailable                         (0),\n"
  "#     multiVehicleAccident                (1),\n"
  "#     heavyAccident                       (2),\n"
  "#     accidentInvolvingLorry              (3),\n"
  "#     accidentInvolvingBus                (4),\n"
  "#     accidentInvolvingHazardousMaterials (5),\n"
  "#     accidentOnOppositeLane              (6),\n"
  "#     unsecuredAccident                   (7),\n"
  "#     assistanceRequested                 (8)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 MULTI_VEHICLE_ACCIDENT = 1\n"
  "uint8 HEAVY_ACCIDENT = 2\n"
  "uint8 ACCIDENT_INVOLVING_LORRY = 3\n"
  "uint8 ACCIDENT_INVOLVING_BUS = 4\n"
  "uint8 ACCIDENT_INVOLVING_HAZARDOUS_MATERIALS = 5\n"
  "uint8 ACCIDENT_ON_OPPOSITE_LANE = 6\n"
  "uint8 UNSECURED_ACCIDENT = 7\n"
  "uint8 ASSISTANCE_REQUESTED = 8\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__TYPE_NAME, 46, 46},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3995, 3995},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__AccidentSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
