// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/ActionId.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/action_id.h"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ACTION_ID__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ACTION_ID__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'originating_station_id'
#include "etsi_its_denm_ts_msgs/msg/detail/station_id__struct.h"
// Member 'sequence_number'
#include "etsi_its_denm_ts_msgs/msg/detail/sequence_number__struct.h"

/// Struct defined in msg/ActionId in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__ActionId
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DF represents an identifier used to describe a protocol action taken by an ITS-S.
  ///  *
  ///  * It shall include the following components:
  ///  *
  ///  * @field originatingStationId: Id of the ITS-S that takes the action.
  ///  *
  ///  * @field sequenceNumber: a sequence number.
  ///  *
  ///  * @category: Communication information
  ///  * @revision: Created in V2.1.1 based on @ref ActionID.
  ///  */
  /// ActionId ::= SEQUENCE {
  ///     originatingStationId    StationId,
  ///     sequenceNumber          SequenceNumber
  /// }
  /// ------------------------------------------------------------------------------
  etsi_its_denm_ts_msgs__msg__StationId originating_station_id;
  etsi_its_denm_ts_msgs__msg__SequenceNumber sequence_number;
} etsi_its_denm_ts_msgs__msg__ActionId;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__ActionId.
typedef struct etsi_its_denm_ts_msgs__msg__ActionId__Sequence
{
  etsi_its_denm_ts_msgs__msg__ActionId * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__ActionId__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ACTION_ID__STRUCT_H_
