// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/ActionId.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/action_id.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ACTION_ID__TRAITS_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ACTION_ID__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "etsi_its_denm_ts_msgs/msg/detail/action_id__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'originating_station_id'
#include "etsi_its_denm_ts_msgs/msg/detail/station_id__traits.hpp"
// Member 'sequence_number'
#include "etsi_its_denm_ts_msgs/msg/detail/sequence_number__traits.hpp"

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ActionId & msg,
  std::ostream & out)
{
  out << "{";
  // member: originating_station_id
  {
    out << "originating_station_id: ";
    to_flow_style_yaml(msg.originating_station_id, out);
    out << ", ";
  }

  // member: sequence_number
  {
    out << "sequence_number: ";
    to_flow_style_yaml(msg.sequence_number, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ActionId & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: originating_station_id
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "originating_station_id:\n";
    to_block_style_yaml(msg.originating_station_id, out, indentation + 2);
  }

  // member: sequence_number
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sequence_number:\n";
    to_block_style_yaml(msg.sequence_number, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ActionId & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

namespace rosidl_generator_traits
{

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const etsi_its_denm_ts_msgs::msg::ActionId & msg,
  std::ostream & out, size_t indentation = 0)
{
  etsi_its_denm_ts_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use etsi_its_denm_ts_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const etsi_its_denm_ts_msgs::msg::ActionId & msg)
{
  return etsi_its_denm_ts_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<etsi_its_denm_ts_msgs::msg::ActionId>()
{
  return "etsi_its_denm_ts_msgs::msg::ActionId";
}

template<>
inline const char * name<etsi_its_denm_ts_msgs::msg::ActionId>()
{
  return "etsi_its_denm_ts_msgs/msg/ActionId";
}

template<>
struct has_fixed_size<etsi_its_denm_ts_msgs::msg::ActionId>
  : std::integral_constant<bool, has_fixed_size<etsi_its_denm_ts_msgs::msg::SequenceNumber>::value && has_fixed_size<etsi_its_denm_ts_msgs::msg::StationId>::value> {};

template<>
struct has_bounded_size<etsi_its_denm_ts_msgs::msg::ActionId>
  : std::integral_constant<bool, has_bounded_size<etsi_its_denm_ts_msgs::msg::SequenceNumber>::value && has_bounded_size<etsi_its_denm_ts_msgs::msg::StationId>::value> {};

template<>
struct is_message<etsi_its_denm_ts_msgs::msg::ActionId>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ACTION_ID__TRAITS_HPP_
