// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/LanePosition.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/lane_position__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__LanePosition__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x27, 0xf5, 0x20, 0x0c, 0x69, 0x22, 0x74, 0x0d,
      0x23, 0x55, 0x82, 0x10, 0x81, 0xa9, 0x1b, 0xb7,
      0x4f, 0x28, 0x36, 0xb7, 0xa6, 0xdb, 0xcf, 0xad,
      0x2a, 0xe4, 0x6a, 0xe4, 0x9f, 0xc3, 0xde, 0xf2,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__LanePosition__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/LanePosition";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__LanePosition__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__LanePosition__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__LanePosition__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__LanePosition__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__LanePosition__TYPE_NAME, 38, 38},
      {etsi_its_denm_ts_msgs__msg__LanePosition__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE indicates a transversal position on the carriageway at a specific longitudinal position, in resolution of lanes of the carriageway. \n"
  "#  *\n"
  "#  * For right-hand traffic roads, the value shall be set to:\n"
  "#  * - `-1` if the position is off, i.e. besides the road,\n"
  "#  * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the leftmost lane,\n"
  "#  * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the leftmost lane to the rightmost lane of a specific traffic direction,\n"
  "#  * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to rightmost lane (if present).\n"
  "#  *\n"
  "#  * For left-hand traffic roads, the value shall be set to:\n"
  "#  * - `-1` if the position is off, i.e. besides the road,\n"
  "#  * - `0` if the position is on the inner hard shoulder, i.e. the hard should adjacent to the rightmost lane,\n"
  "#  * - `n` (`n > 0` and `n < 14`), if the position is on the n-th driving lane counted from the rightmost lane to the leftmost lane of a specific traffic direction,\n"
  "#  * - `14` if the position is on the outer hard shoulder, i.e. the hard should adjacent to leftmost lane (if present).\n"
  "#  *\n"
  "#  *  @note: in practice this means that the position is counted from \"inside\" to \"outside\" no matter which traffic practice is used.\n"
  "#  *\n"
  "#  * If the carriageway allows only traffic in one direction (e.g. in case of dual or multiple carriageway roads), the position is counted from the physical border of the carriageway. \n"
  "#  * If the carriageway allows traffic in both directions and there is no physical delimitation between traffic directions (e.g. on a single carrriageway road), \n"
  "#  * the position is counted from the legal (i.e. optical) separation between traffic directions (horizontal marking). \n"
  "#  *\n"
  "#  * If not indicated otherwise (by lane markings or traffic signs), the legal separation on carriageways allowing traffic on both directions is identified as follows:\n"
  "#  * - If the total number of lanes N is even, the lanes are divided evenly between the traffic directions starting from the outside of the carriageway on both sides and the \n"
  "#  *   imaginary separation between traffic directions is on the border between the even number of lanes N/2.\n"
  "#  * - If the total number of lanes N is odd, the lanes are divided evenly between traffic direction starting from the outside of the carriageway on both sides. \n"
  "#  *   The remaining middle lane is assigned to both traffic directions as innermost lane.\n"
  "#  *\n"
  "#  * @category: Road topology information\n"
  "#  * @revision: Description of the legal separation of carriageways added in V2.2.1\n"
  "# */\n"
  "# LanePosition ::= INTEGER {\n"
  "#     offTheRoad           (-1), \n"
  "#     innerHardShoulder    (0), \n"
  "#     outerHardShoulder    (14) \n"
  "# } (-1..14)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "int8 value\n"
  "int8 MIN = -1\n"
  "int8 MAX = 14\n"
  "int8 OFF_THE_ROAD = -1\n"
  "int8 INNER_HARD_SHOULDER = 0\n"
  "int8 OUTER_HARD_SHOULDER = 14\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__LanePosition__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__LanePosition__TYPE_NAME, 38, 38},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 4802, 4802},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__LanePosition__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__LanePosition__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
