// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/PositioningSolutionType.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/positioning_solution_type.h"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__POSITIONING_SOLUTION_TYPE__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__POSITIONING_SOLUTION_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'NO_POSITIONING_SOLUTION'.
enum
{
  etsi_its_denm_ts_msgs__msg__PositioningSolutionType__NO_POSITIONING_SOLUTION = 0
};

/// Constant 'S_GNSS'.
enum
{
  etsi_its_denm_ts_msgs__msg__PositioningSolutionType__S_GNSS = 1
};

/// Constant 'D_GNSS'.
enum
{
  etsi_its_denm_ts_msgs__msg__PositioningSolutionType__D_GNSS = 2
};

/// Constant 'S_GNS_SPLUS_DR'.
enum
{
  etsi_its_denm_ts_msgs__msg__PositioningSolutionType__S_GNS_SPLUS_DR = 3
};

/// Constant 'D_GNS_SPLUS_DR'.
enum
{
  etsi_its_denm_ts_msgs__msg__PositioningSolutionType__D_GNS_SPLUS_DR = 4
};

/// Constant 'D_R'.
enum
{
  etsi_its_denm_ts_msgs__msg__PositioningSolutionType__D_R = 5
};

/// Constant 'MANUALLY_BY_OPERATOR'.
enum
{
  etsi_its_denm_ts_msgs__msg__PositioningSolutionType__MANUALLY_BY_OPERATOR = 6
};

/// Struct defined in msg/PositioningSolutionType in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__PositioningSolutionType
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the positioning technology being used to estimate a geographical position.
  ///  *
  ///  * The value shall be set to:
  ///  * - 0 `noPositioningSolution`  - no positioning solution used,
  ///  * - 1 `sGNSS`                  - Global Navigation Satellite System used,
  ///  * - 2 `dGNSS`                  - Differential GNSS used,
  ///  * - 3 `sGNSSplusDR`            - GNSS and dead reckoning used,
  ///  * - 4 `dGNSSplusDR`            - Differential GNSS and dead reckoning used,
  ///  * - 5 `dR`                     - dead reckoning used,
  ///  * - 6 `manuallyByOperator`     - position set manually by a human operator.
  ///  *
  ///  * @category: GeoReference information
  ///  * @revision: V1.3.1, extension with value 6 added in V2.2.1
  ///  */
  /// PositioningSolutionType ::= ENUMERATED {
  ///     noPositioningSolution (0),
  ///     sGNSS                 (1),
  ///     dGNSS                 (2),
  ///     sGNSSplusDR           (3),
  ///     dGNSSplusDR           (4),
  ///     dR                    (5),
  ///     ...,
  ///     manuallyByOperator    (6)
  /// }
  /// ------------------------------------------------------------------------------
  uint8_t value;
} etsi_its_denm_ts_msgs__msg__PositioningSolutionType;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__PositioningSolutionType.
typedef struct etsi_its_denm_ts_msgs__msg__PositioningSolutionType__Sequence
{
  etsi_its_denm_ts_msgs__msg__PositioningSolutionType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__PositioningSolutionType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__POSITIONING_SOLUTION_TYPE__STRUCT_H_
