// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/RoadConfigurationContainer.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/road_configuration_container.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_CONTAINER__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_CONTAINER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'road_configuration_confidence'
#include "etsi_its_denm_ts_msgs/msg/detail/meta_information__struct.hpp"
// Member 'road_configuration_section_list'
#include "etsi_its_denm_ts_msgs/msg/detail/road_configuration_section_list__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadConfigurationContainer __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadConfigurationContainer __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadConfigurationContainer_
{
  using Type = RoadConfigurationContainer_<ContainerAllocator>;

  explicit RoadConfigurationContainer_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_configuration_confidence(_init),
    road_configuration_section_list(_init)
  {
    (void)_init;
  }

  explicit RoadConfigurationContainer_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : road_configuration_confidence(_alloc, _init),
    road_configuration_section_list(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _road_configuration_confidence_type =
    etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator>;
  _road_configuration_confidence_type road_configuration_confidence;
  using _road_configuration_section_list_type =
    etsi_its_denm_ts_msgs::msg::RoadConfigurationSectionList_<ContainerAllocator>;
  _road_configuration_section_list_type road_configuration_section_list;

  // setters for named parameter idiom
  Type & set__road_configuration_confidence(
    const etsi_its_denm_ts_msgs::msg::MetaInformation_<ContainerAllocator> & _arg)
  {
    this->road_configuration_confidence = _arg;
    return *this;
  }
  Type & set__road_configuration_section_list(
    const etsi_its_denm_ts_msgs::msg::RoadConfigurationSectionList_<ContainerAllocator> & _arg)
  {
    this->road_configuration_section_list = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadConfigurationContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadConfigurationContainer
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadConfigurationContainer_ & other) const
  {
    if (this->road_configuration_confidence != other.road_configuration_confidence) {
      return false;
    }
    if (this->road_configuration_section_list != other.road_configuration_section_list) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadConfigurationContainer_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadConfigurationContainer_

// alias to use template instance with default allocator
using RoadConfigurationContainer =
  etsi_its_denm_ts_msgs::msg::RoadConfigurationContainer_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_CONFIGURATION_CONTAINER__STRUCT_HPP_
