// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/RoadSectionDefinition.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/road_section_definition.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_SECTION_DEFINITION__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_SECTION_DEFINITION__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'starting_point_section'
// Member 'ending_point_section'
#include "etsi_its_denm_ts_msgs/msg/detail/geo_position__struct.hpp"
// Member 'length_of_section'
#include "etsi_its_denm_ts_msgs/msg/detail/standard_length2_b__struct.hpp"
// Member 'connected_paths'
// Member 'included_paths'
#include "etsi_its_denm_ts_msgs/msg/detail/path_references__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadSectionDefinition __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadSectionDefinition __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadSectionDefinition_
{
  using Type = RoadSectionDefinition_<ContainerAllocator>;

  explicit RoadSectionDefinition_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : starting_point_section(_init),
    length_of_section(_init),
    ending_point_section(_init),
    connected_paths(_init),
    included_paths(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->length_of_section_is_present = false;
      this->ending_point_section_is_present = false;
      this->is_event_zone_included = false;
      this->is_event_zone_connected = false;
    }
  }

  explicit RoadSectionDefinition_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : starting_point_section(_alloc, _init),
    length_of_section(_alloc, _init),
    ending_point_section(_alloc, _init),
    connected_paths(_alloc, _init),
    included_paths(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->length_of_section_is_present = false;
      this->ending_point_section_is_present = false;
      this->is_event_zone_included = false;
      this->is_event_zone_connected = false;
    }
  }

  // field types and members
  using _starting_point_section_type =
    etsi_its_denm_ts_msgs::msg::GeoPosition_<ContainerAllocator>;
  _starting_point_section_type starting_point_section;
  using _length_of_section_type =
    etsi_its_denm_ts_msgs::msg::StandardLength2B_<ContainerAllocator>;
  _length_of_section_type length_of_section;
  using _length_of_section_is_present_type =
    bool;
  _length_of_section_is_present_type length_of_section_is_present;
  using _ending_point_section_type =
    etsi_its_denm_ts_msgs::msg::GeoPosition_<ContainerAllocator>;
  _ending_point_section_type ending_point_section;
  using _ending_point_section_is_present_type =
    bool;
  _ending_point_section_is_present_type ending_point_section_is_present;
  using _connected_paths_type =
    etsi_its_denm_ts_msgs::msg::PathReferences_<ContainerAllocator>;
  _connected_paths_type connected_paths;
  using _included_paths_type =
    etsi_its_denm_ts_msgs::msg::PathReferences_<ContainerAllocator>;
  _included_paths_type included_paths;
  using _is_event_zone_included_type =
    bool;
  _is_event_zone_included_type is_event_zone_included;
  using _is_event_zone_connected_type =
    bool;
  _is_event_zone_connected_type is_event_zone_connected;

  // setters for named parameter idiom
  Type & set__starting_point_section(
    const etsi_its_denm_ts_msgs::msg::GeoPosition_<ContainerAllocator> & _arg)
  {
    this->starting_point_section = _arg;
    return *this;
  }
  Type & set__length_of_section(
    const etsi_its_denm_ts_msgs::msg::StandardLength2B_<ContainerAllocator> & _arg)
  {
    this->length_of_section = _arg;
    return *this;
  }
  Type & set__length_of_section_is_present(
    const bool & _arg)
  {
    this->length_of_section_is_present = _arg;
    return *this;
  }
  Type & set__ending_point_section(
    const etsi_its_denm_ts_msgs::msg::GeoPosition_<ContainerAllocator> & _arg)
  {
    this->ending_point_section = _arg;
    return *this;
  }
  Type & set__ending_point_section_is_present(
    const bool & _arg)
  {
    this->ending_point_section_is_present = _arg;
    return *this;
  }
  Type & set__connected_paths(
    const etsi_its_denm_ts_msgs::msg::PathReferences_<ContainerAllocator> & _arg)
  {
    this->connected_paths = _arg;
    return *this;
  }
  Type & set__included_paths(
    const etsi_its_denm_ts_msgs::msg::PathReferences_<ContainerAllocator> & _arg)
  {
    this->included_paths = _arg;
    return *this;
  }
  Type & set__is_event_zone_included(
    const bool & _arg)
  {
    this->is_event_zone_included = _arg;
    return *this;
  }
  Type & set__is_event_zone_connected(
    const bool & _arg)
  {
    this->is_event_zone_connected = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadSectionDefinition
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadSectionDefinition
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadSectionDefinition_ & other) const
  {
    if (this->starting_point_section != other.starting_point_section) {
      return false;
    }
    if (this->length_of_section != other.length_of_section) {
      return false;
    }
    if (this->length_of_section_is_present != other.length_of_section_is_present) {
      return false;
    }
    if (this->ending_point_section != other.ending_point_section) {
      return false;
    }
    if (this->ending_point_section_is_present != other.ending_point_section_is_present) {
      return false;
    }
    if (this->connected_paths != other.connected_paths) {
      return false;
    }
    if (this->included_paths != other.included_paths) {
      return false;
    }
    if (this->is_event_zone_included != other.is_event_zone_included) {
      return false;
    }
    if (this->is_event_zone_connected != other.is_event_zone_connected) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadSectionDefinition_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadSectionDefinition_

// alias to use template instance with default allocator
using RoadSectionDefinition =
  etsi_its_denm_ts_msgs::msg::RoadSectionDefinition_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_SECTION_DEFINITION__STRUCT_HPP_
