// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from etsi_its_denm_ts_msgs:msg/RoadWorksContainerExtended.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/road_works_container_extended.hpp"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_EXTENDED__STRUCT_HPP_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_EXTENDED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'light_bar_siren_in_use'
#include "etsi_its_denm_ts_msgs/msg/detail/light_bar_siren_in_use__struct.hpp"
// Member 'closed_lanes'
#include "etsi_its_denm_ts_msgs/msg/detail/closed_lanes__struct.hpp"
// Member 'restriction'
#include "etsi_its_denm_ts_msgs/msg/detail/restricted_types__struct.hpp"
// Member 'speed_limit'
#include "etsi_its_denm_ts_msgs/msg/detail/speed_limit__struct.hpp"
// Member 'incident_indication'
#include "etsi_its_denm_ts_msgs/msg/detail/cause_code_v2__struct.hpp"
// Member 'recommended_path'
#include "etsi_its_denm_ts_msgs/msg/detail/itinerary_path__struct.hpp"
// Member 'starting_point_speed_limit'
#include "etsi_its_denm_ts_msgs/msg/detail/delta_reference_position__struct.hpp"
// Member 'traffic_flow_rule'
#include "etsi_its_denm_ts_msgs/msg/detail/traffic_rule__struct.hpp"
// Member 'reference_denms'
#include "etsi_its_denm_ts_msgs/msg/detail/action_id_list__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadWorksContainerExtended __attribute__((deprecated))
#else
# define DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadWorksContainerExtended __declspec(deprecated)
#endif

namespace etsi_its_denm_ts_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RoadWorksContainerExtended_
{
  using Type = RoadWorksContainerExtended_<ContainerAllocator>;

  explicit RoadWorksContainerExtended_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : light_bar_siren_in_use(_init),
    closed_lanes(_init),
    restriction(_init),
    speed_limit(_init),
    incident_indication(_init),
    recommended_path(_init),
    starting_point_speed_limit(_init),
    traffic_flow_rule(_init),
    reference_denms(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->light_bar_siren_in_use_is_present = false;
      this->closed_lanes_is_present = false;
      this->restriction_is_present = false;
      this->speed_limit_is_present = false;
      this->incident_indication_is_present = false;
      this->recommended_path_is_present = false;
      this->starting_point_speed_limit_is_present = false;
      this->traffic_flow_rule_is_present = false;
      this->reference_denms_is_present = false;
    }
  }

  explicit RoadWorksContainerExtended_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : light_bar_siren_in_use(_alloc, _init),
    closed_lanes(_alloc, _init),
    restriction(_alloc, _init),
    speed_limit(_alloc, _init),
    incident_indication(_alloc, _init),
    recommended_path(_alloc, _init),
    starting_point_speed_limit(_alloc, _init),
    traffic_flow_rule(_alloc, _init),
    reference_denms(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->light_bar_siren_in_use_is_present = false;
      this->closed_lanes_is_present = false;
      this->restriction_is_present = false;
      this->speed_limit_is_present = false;
      this->incident_indication_is_present = false;
      this->recommended_path_is_present = false;
      this->starting_point_speed_limit_is_present = false;
      this->traffic_flow_rule_is_present = false;
      this->reference_denms_is_present = false;
    }
  }

  // field types and members
  using _light_bar_siren_in_use_type =
    etsi_its_denm_ts_msgs::msg::LightBarSirenInUse_<ContainerAllocator>;
  _light_bar_siren_in_use_type light_bar_siren_in_use;
  using _light_bar_siren_in_use_is_present_type =
    bool;
  _light_bar_siren_in_use_is_present_type light_bar_siren_in_use_is_present;
  using _closed_lanes_type =
    etsi_its_denm_ts_msgs::msg::ClosedLanes_<ContainerAllocator>;
  _closed_lanes_type closed_lanes;
  using _closed_lanes_is_present_type =
    bool;
  _closed_lanes_is_present_type closed_lanes_is_present;
  using _restriction_type =
    etsi_its_denm_ts_msgs::msg::RestrictedTypes_<ContainerAllocator>;
  _restriction_type restriction;
  using _restriction_is_present_type =
    bool;
  _restriction_is_present_type restriction_is_present;
  using _speed_limit_type =
    etsi_its_denm_ts_msgs::msg::SpeedLimit_<ContainerAllocator>;
  _speed_limit_type speed_limit;
  using _speed_limit_is_present_type =
    bool;
  _speed_limit_is_present_type speed_limit_is_present;
  using _incident_indication_type =
    etsi_its_denm_ts_msgs::msg::CauseCodeV2_<ContainerAllocator>;
  _incident_indication_type incident_indication;
  using _incident_indication_is_present_type =
    bool;
  _incident_indication_is_present_type incident_indication_is_present;
  using _recommended_path_type =
    etsi_its_denm_ts_msgs::msg::ItineraryPath_<ContainerAllocator>;
  _recommended_path_type recommended_path;
  using _recommended_path_is_present_type =
    bool;
  _recommended_path_is_present_type recommended_path_is_present;
  using _starting_point_speed_limit_type =
    etsi_its_denm_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator>;
  _starting_point_speed_limit_type starting_point_speed_limit;
  using _starting_point_speed_limit_is_present_type =
    bool;
  _starting_point_speed_limit_is_present_type starting_point_speed_limit_is_present;
  using _traffic_flow_rule_type =
    etsi_its_denm_ts_msgs::msg::TrafficRule_<ContainerAllocator>;
  _traffic_flow_rule_type traffic_flow_rule;
  using _traffic_flow_rule_is_present_type =
    bool;
  _traffic_flow_rule_is_present_type traffic_flow_rule_is_present;
  using _reference_denms_type =
    etsi_its_denm_ts_msgs::msg::ActionIdList_<ContainerAllocator>;
  _reference_denms_type reference_denms;
  using _reference_denms_is_present_type =
    bool;
  _reference_denms_is_present_type reference_denms_is_present;

  // setters for named parameter idiom
  Type & set__light_bar_siren_in_use(
    const etsi_its_denm_ts_msgs::msg::LightBarSirenInUse_<ContainerAllocator> & _arg)
  {
    this->light_bar_siren_in_use = _arg;
    return *this;
  }
  Type & set__light_bar_siren_in_use_is_present(
    const bool & _arg)
  {
    this->light_bar_siren_in_use_is_present = _arg;
    return *this;
  }
  Type & set__closed_lanes(
    const etsi_its_denm_ts_msgs::msg::ClosedLanes_<ContainerAllocator> & _arg)
  {
    this->closed_lanes = _arg;
    return *this;
  }
  Type & set__closed_lanes_is_present(
    const bool & _arg)
  {
    this->closed_lanes_is_present = _arg;
    return *this;
  }
  Type & set__restriction(
    const etsi_its_denm_ts_msgs::msg::RestrictedTypes_<ContainerAllocator> & _arg)
  {
    this->restriction = _arg;
    return *this;
  }
  Type & set__restriction_is_present(
    const bool & _arg)
  {
    this->restriction_is_present = _arg;
    return *this;
  }
  Type & set__speed_limit(
    const etsi_its_denm_ts_msgs::msg::SpeedLimit_<ContainerAllocator> & _arg)
  {
    this->speed_limit = _arg;
    return *this;
  }
  Type & set__speed_limit_is_present(
    const bool & _arg)
  {
    this->speed_limit_is_present = _arg;
    return *this;
  }
  Type & set__incident_indication(
    const etsi_its_denm_ts_msgs::msg::CauseCodeV2_<ContainerAllocator> & _arg)
  {
    this->incident_indication = _arg;
    return *this;
  }
  Type & set__incident_indication_is_present(
    const bool & _arg)
  {
    this->incident_indication_is_present = _arg;
    return *this;
  }
  Type & set__recommended_path(
    const etsi_its_denm_ts_msgs::msg::ItineraryPath_<ContainerAllocator> & _arg)
  {
    this->recommended_path = _arg;
    return *this;
  }
  Type & set__recommended_path_is_present(
    const bool & _arg)
  {
    this->recommended_path_is_present = _arg;
    return *this;
  }
  Type & set__starting_point_speed_limit(
    const etsi_its_denm_ts_msgs::msg::DeltaReferencePosition_<ContainerAllocator> & _arg)
  {
    this->starting_point_speed_limit = _arg;
    return *this;
  }
  Type & set__starting_point_speed_limit_is_present(
    const bool & _arg)
  {
    this->starting_point_speed_limit_is_present = _arg;
    return *this;
  }
  Type & set__traffic_flow_rule(
    const etsi_its_denm_ts_msgs::msg::TrafficRule_<ContainerAllocator> & _arg)
  {
    this->traffic_flow_rule = _arg;
    return *this;
  }
  Type & set__traffic_flow_rule_is_present(
    const bool & _arg)
  {
    this->traffic_flow_rule_is_present = _arg;
    return *this;
  }
  Type & set__reference_denms(
    const etsi_its_denm_ts_msgs::msg::ActionIdList_<ContainerAllocator> & _arg)
  {
    this->reference_denms = _arg;
    return *this;
  }
  Type & set__reference_denms_is_present(
    const bool & _arg)
  {
    this->reference_denms_is_present = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator> *;
  using ConstRawPtr =
    const etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadWorksContainerExtended
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__etsi_its_denm_ts_msgs__msg__RoadWorksContainerExtended
    std::shared_ptr<etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RoadWorksContainerExtended_ & other) const
  {
    if (this->light_bar_siren_in_use != other.light_bar_siren_in_use) {
      return false;
    }
    if (this->light_bar_siren_in_use_is_present != other.light_bar_siren_in_use_is_present) {
      return false;
    }
    if (this->closed_lanes != other.closed_lanes) {
      return false;
    }
    if (this->closed_lanes_is_present != other.closed_lanes_is_present) {
      return false;
    }
    if (this->restriction != other.restriction) {
      return false;
    }
    if (this->restriction_is_present != other.restriction_is_present) {
      return false;
    }
    if (this->speed_limit != other.speed_limit) {
      return false;
    }
    if (this->speed_limit_is_present != other.speed_limit_is_present) {
      return false;
    }
    if (this->incident_indication != other.incident_indication) {
      return false;
    }
    if (this->incident_indication_is_present != other.incident_indication_is_present) {
      return false;
    }
    if (this->recommended_path != other.recommended_path) {
      return false;
    }
    if (this->recommended_path_is_present != other.recommended_path_is_present) {
      return false;
    }
    if (this->starting_point_speed_limit != other.starting_point_speed_limit) {
      return false;
    }
    if (this->starting_point_speed_limit_is_present != other.starting_point_speed_limit_is_present) {
      return false;
    }
    if (this->traffic_flow_rule != other.traffic_flow_rule) {
      return false;
    }
    if (this->traffic_flow_rule_is_present != other.traffic_flow_rule_is_present) {
      return false;
    }
    if (this->reference_denms != other.reference_denms) {
      return false;
    }
    if (this->reference_denms_is_present != other.reference_denms_is_present) {
      return false;
    }
    return true;
  }
  bool operator!=(const RoadWorksContainerExtended_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RoadWorksContainerExtended_

// alias to use template instance with default allocator
using RoadWorksContainerExtended =
  etsi_its_denm_ts_msgs::msg::RoadWorksContainerExtended_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace etsi_its_denm_ts_msgs

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__ROAD_WORKS_CONTAINER_EXTENDED__STRUCT_HPP_
