// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/StoredInformationType.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/stored_information_type__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__StoredInformationType__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xd1, 0xee, 0x32, 0xfb, 0x4b, 0x27, 0xe2, 0x1d,
      0x57, 0x27, 0xba, 0x48, 0x09, 0x98, 0xa5, 0xba,
      0x76, 0xea, 0xc4, 0xab, 0x26, 0xa2, 0x85, 0x6a,
      0xee, 0x19, 0x1b, 0x28, 0xc7, 0xc0, 0xcf, 0x26,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__StoredInformationType__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/StoredInformationType";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__StoredInformationType__FIELD_NAME__value[] = "value";
static char etsi_its_denm_ts_msgs__msg__StoredInformationType__FIELD_NAME__bits_unused[] = "bits_unused";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__StoredInformationType__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__StoredInformationType__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {etsi_its_denm_ts_msgs__msg__StoredInformationType__FIELD_NAME__bits_unused, 11, 11},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__StoredInformationType__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__StoredInformationType__TYPE_NAME, 47, 47},
      {etsi_its_denm_ts_msgs__msg__StoredInformationType__FIELDS, 2, 2},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /** \n"
  "#  * This DE indicates the type of stored information.\n"
  "#  *\n"
  "#  * The corresponding bit shall be set to 1 under the following conditions:\n"
  "#  * \n"
  "#  * - `0` undefined        - in case the stored information type is undefined. \n"
  "#  * - `1` staticDb         - in case the stored information type is a static database.\n"
  "#  * - `2` dynamicDb        - in case the stored information type is a dynamic database\n"
  "#  * - `3` realTimeDb       - in case the stored information type is a real time updated database.\n"
  "#  * - `4` map              - in case the stored information type is a road topology map.\n"
  "#  * - Bits 5 to 7          - are reserved for future use.\n"
  "#  *\n"
  "#  * @note: If all bits are set to 0, then no stored information type is used\n"
  "#  *\n"
  "#  * @category: Basic Information\n"
  "#  * @revision: created in V2.2.1\n"
  "# */\n"
  "# StoredInformationType::= BIT STRING {\n"
  "#     undefined       (0),\n"
  "#     staticDb\\t    (1),    \n"
  "#     dynamicDb   \\t(2),\n"
  "#     realTimeDb  \\t(3),\n"
  "#     map\\t\\t    \\t(4)\\t\n"
  "# } (SIZE (8,... )) \n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8[] value\n"
  "uint8 bits_unused\n"
  "uint8 SIZE_BITS = 8\n"
  "uint8 BIT_INDEX_UNDEFINED = 0\n"
  "uint8 BIT_INDEX_STATIC_DB = 1\n"
  "uint8 BIT_INDEX_DYNAMIC_DB = 2\n"
  "uint8 BIT_INDEX_REAL_TIME_DB = 3\n"
  "uint8 BIT_INDEX_MAP = 4\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__StoredInformationType__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__StoredInformationType__TYPE_NAME, 47, 47},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 3087, 3087},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__StoredInformationType__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__StoredInformationType__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
