// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from etsi_its_denm_ts_msgs:msg/StoredInformationType.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "etsi_its_denm_ts_msgs/msg/stored_information_type.h"


#ifndef ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__STORED_INFORMATION_TYPE__STRUCT_H_
#define ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__STORED_INFORMATION_TYPE__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

/// Constant 'SIZE_BITS'.
enum
{
  etsi_its_denm_ts_msgs__msg__StoredInformationType__SIZE_BITS = 8
};

/// Constant 'BIT_INDEX_UNDEFINED'.
enum
{
  etsi_its_denm_ts_msgs__msg__StoredInformationType__BIT_INDEX_UNDEFINED = 0
};

/// Constant 'BIT_INDEX_STATIC_DB'.
enum
{
  etsi_its_denm_ts_msgs__msg__StoredInformationType__BIT_INDEX_STATIC_DB = 1
};

/// Constant 'BIT_INDEX_DYNAMIC_DB'.
enum
{
  etsi_its_denm_ts_msgs__msg__StoredInformationType__BIT_INDEX_DYNAMIC_DB = 2
};

/// Constant 'BIT_INDEX_REAL_TIME_DB'.
enum
{
  etsi_its_denm_ts_msgs__msg__StoredInformationType__BIT_INDEX_REAL_TIME_DB = 3
};

/// Constant 'BIT_INDEX_MAP'.
enum
{
  etsi_its_denm_ts_msgs__msg__StoredInformationType__BIT_INDEX_MAP = 4
};

// Include directives for member types
// Member 'value'
#include "rosidl_runtime_c/primitives_sequence.h"

/// Struct defined in msg/StoredInformationType in the package etsi_its_denm_ts_msgs.
/**
  * ==============================================================================
  * MIT License
  *
  * Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University
  *
  * Permission is hereby granted, free of charge, to any person obtaining a copy
  * of this software and associated documentation files (the "Software"), to deal
  * in the Software without restriction, including without limitation the rights
  * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
  * copies of the Software, and to permit persons to whom the Software is
  * furnished to do so, subject to the following conditions:
  *
  * The above copyright notice and this permission notice shall be included in all
  * copies or substantial portions of the Software.
  *
  * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
  * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
  * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
  * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
  * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
  * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
  * SOFTWARE.
  * ==============================================================================
 */
typedef struct etsi_its_denm_ts_msgs__msg__StoredInformationType
{
  /// --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---
  /// python3
  ///   utils/codegen/codegen-py/asn1ToRosMsg.py
  ///   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn
  ///   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn
  ///   -t
  ///   denm_ts
  ///   -o
  ///   etsi_its_msgs/etsi_its_denm_ts_msgs/msg
  /// ------------------------------------------------------------------------------
  /// --- ASN.1 Definition ---------------------------------------------------------
  /// /**
  ///  * This DE indicates the type of stored information.
  ///  *
  ///  * The corresponding bit shall be set to 1 under the following conditions:
  ///  *
  ///  * - `0` undefined        - in case the stored information type is undefined.
  ///  * - `1` staticDb         - in case the stored information type is a static database.
  ///  * - `2` dynamicDb        - in case the stored information type is a dynamic database
  ///  * - `3` realTimeDb       - in case the stored information type is a real time updated database.
  ///  * - `4` map              - in case the stored information type is a road topology map.
  ///  * - Bits 5 to 7          - are reserved for future use.
  ///  *
  ///  * @note: If all bits are set to 0, then no stored information type is used
  ///  *
  ///  * @category: Basic Information
  ///  * @revision: created in V2.2.1
  /// */
  /// StoredInformationType::= BIT STRING {
  ///     undefined       (0),
  ///     staticDb     (1),
  ///     dynamicDb    (2),
  ///     realTimeDb   (3),
  ///     map       (4)
  /// } (SIZE (8,... ))
  /// ------------------------------------------------------------------------------
  rosidl_runtime_c__uint8__Sequence value;
  uint8_t bits_unused;
} etsi_its_denm_ts_msgs__msg__StoredInformationType;

// Struct for a sequence of etsi_its_denm_ts_msgs__msg__StoredInformationType.
typedef struct etsi_its_denm_ts_msgs__msg__StoredInformationType__Sequence
{
  etsi_its_denm_ts_msgs__msg__StoredInformationType * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} etsi_its_denm_ts_msgs__msg__StoredInformationType__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ETSI_ITS_DENM_TS_MSGS__MSG__DETAIL__STORED_INFORMATION_TYPE__STRUCT_H_
