// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from etsi_its_denm_ts_msgs:msg/TrafficConditionSubCauseCode.idl
// generated code does not contain a copyright notice

#include "etsi_its_denm_ts_msgs/msg/detail/traffic_condition_sub_cause_code__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_etsi_its_denm_ts_msgs
const rosidl_type_hash_t *
etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0x3a, 0x45, 0xee, 0x8f, 0x27, 0xa3, 0x17, 0xeb,
      0x87, 0xf5, 0x07, 0xf2, 0x87, 0xe6, 0x28, 0xf4,
      0xdd, 0xba, 0xcb, 0x74, 0xcc, 0xe4, 0xac, 0x3c,
      0x5c, 0x00, 0x79, 0xaf, 0x57, 0x04, 0xa7, 0x0d,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types

// Hashes for external referenced types
#ifndef NDEBUG
#endif

static char etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__TYPE_NAME[] = "etsi_its_denm_ts_msgs/msg/TrafficConditionSubCauseCode";

// Define type names, field names, and default values
static char etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__FIELD_NAME__value[] = "value";

static rosidl_runtime_c__type_description__Field etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__FIELDS[] = {
  {
    {etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__FIELD_NAME__value, 5, 5},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_UINT8,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__TYPE_NAME, 54, 54},
      {etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__FIELDS, 1, 1},
    },
    {NULL, 0, 0},
  };
  if (!constructed) {
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# ==============================================================================\n"
  "# MIT License\n"
  "#\n"
  "# Copyright (c) 2023-2025 Institute for Automotive Engineering (ika), RWTH Aachen University\n"
  "#\n"
  "# Permission is hereby granted, free of charge, to any person obtaining a copy\n"
  "# of this software and associated documentation files (the \"Software\"), to deal\n"
  "# in the Software without restriction, including without limitation the rights\n"
  "# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell\n"
  "# copies of the Software, and to permit persons to whom the Software is\n"
  "# furnished to do so, subject to the following conditions:\n"
  "#\n"
  "# The above copyright notice and this permission notice shall be included in all\n"
  "# copies or substantial portions of the Software.\n"
  "#\n"
  "# THE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\n"
  "# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\n"
  "# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\n"
  "# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\n"
  "# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\n"
  "# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\n"
  "# SOFTWARE.\n"
  "# ==============================================================================\n"
  "\n"
  "# --- Auto-generated by https://github.com/ika-rwth-aachen/etsi_its_messages ---\n"
  "# python3\n"
  "#   utils/codegen/codegen-py/asn1ToRosMsg.py\n"
  "#   asn1/raw/denm_ts103831/DENM-PDU-Descriptions.asn\n"
  "#   asn1/patched/denm_ts103831/cdd/ETSI-ITS-CDD.asn\n"
  "#   -t\n"
  "#   denm_ts\n"
  "#   -o\n"
  "#   etsi_its_msgs/etsi_its_denm_ts_msgs/msg\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "# --- ASN.1 Definition ---------------------------------------------------------\n"
  "# /**\n"
  "#  * This DE represents the value of the sub cause codes of the @ref CauseCode `trafficCondition`. \n"
  "#  * \n"
  "#  * The value shall be set to:\n"
  "#  * - 0 `unavailable`                  - in case further detailed information on the traffic condition is unavailable,\n"
  "#  * - 1 `increasedVolumeOfTraffic`     - in case the type of traffic condition is increased traffic volume,\n"
  "#  * - 2 `trafficJamSlowlyIncreasing`   - in case the type of traffic condition is a traffic jam which volume is increasing slowly,\n"
  "#  * - 3 `trafficJamIncreasing`         - in case the type of traffic condition is a traffic jam which volume is increasing,\n"
  "#  * - 4 `trafficJamStronglyIncreasing` - in case the type of traffic condition is a traffic jam which volume is strongly increasing,\n"
  "#  * - 5 `trafficJam`         `         - in case the type of traffic condition is a traffic jam and no further detailed information about its volume is available,\n"
  "#  * - 6 `trafficJamSlightlyDecreasing` - in case the type of traffic condition is a traffic jam which volume is decreasing slowly,\n"
  "#  * - 7 `trafficJamDecreasing`         - in case the type of traffic condition is a traffic jam which volume is decreasing,\n"
  "#  * - 8 `trafficJamStronglyDecreasing` - in case the type of traffic condition is a traffic jam which volume is decreasing rapidly,\n"
  "#  * - 9 `trafficJamStable`             - in case the traffic condition is a traffic jam with stable volume,\n"
  "#  * - 10-255: reserved for future usage.\n"
  "#  *\n"
  "#  * @category: Traffic information\n"
  "#  * @revision: V1.3.1, definition of value 0 and 1 changed in V2.2.1, name and definition of value 5 changed in V2.2.1, value 9 added in V2.2.1\n"
  "#  */\n"
  "# TrafficConditionSubCauseCode ::= INTEGER {\n"
  "#     unavailable                  (0),\n"
  "#     increasedVolumeOfTraffic     (1),\n"
  "#     trafficJamSlowlyIncreasing   (2),\n"
  "#     trafficJamIncreasing         (3),\n"
  "#     trafficJamStronglyIncreasing (4),\n"
  "#     trafficJam                   (5),\n"
  "#     trafficJamSlightlyDecreasing (6),\n"
  "#     trafficJamDecreasing         (7),\n"
  "#     trafficJamStronglyDecreasing (8),\n"
  "#     trafficJamStable             (9)\n"
  "# } (0..255)\n"
  "# ------------------------------------------------------------------------------\n"
  "\n"
  "uint8 value\n"
  "uint8 MIN = 0\n"
  "uint8 MAX = 255\n"
  "uint8 UNAVAILABLE = 0\n"
  "uint8 INCREASED_VOLUME_OF_TRAFFIC = 1\n"
  "uint8 TRAFFIC_JAM_SLOWLY_INCREASING = 2\n"
  "uint8 TRAFFIC_JAM_INCREASING = 3\n"
  "uint8 TRAFFIC_JAM_STRONGLY_INCREASING = 4\n"
  "uint8 TRAFFIC_JAM = 5\n"
  "uint8 TRAFFIC_JAM_SLIGHTLY_DECREASING = 6\n"
  "uint8 TRAFFIC_JAM_DECREASING = 7\n"
  "uint8 TRAFFIC_JAM_STRONGLY_DECREASING = 8\n"
  "uint8 TRAFFIC_JAM_STABLE = 9\n"
  "";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__TYPE_NAME, 54, 54},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 4389, 4389},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[1];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 1, 1};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *etsi_its_denm_ts_msgs__msg__TrafficConditionSubCauseCode__get_individual_type_description_source(NULL),
    constructed = true;
  }
  return &source_sequence;
}
